status_bolo = stat {
	nam = function(s)
		p (img('pad:0 60,gfx/Bolo.png'));
		p ('^'..img('pad:0 3 0 15,gfx/icon_shield_24.png'), global_var_bolo_life, '%  ');
		p (''..img('pad:0 3 0 15,gfx/clock-24.png'), global_var_bolo_count, 'ч.^');
	end;
};

bolo = player {
        nam = 'Боло';
        where = 'random_planet';
        obj = {};
};

random_planet = room {
	nam = 'Планета';
	forcedsc = true;
	nolife = true;
	pic = function()
		return (field_bolo);
	end;
	dsc = function()
		local i = rnd(3);
		if pl.where == 'Limbo' then p 'Песок и пепел скрипят под моими гусеницами. Я веду поиск, но на этой выжженной планете ничто не могло уцелеть.';
		elseif pl.where == 'Omicron_Persey' then p 'Каменистая равнина покрыта красными лишайниками и вьющимися растениями. Еду на полной скорости.';
		elseif global_var_random_planet == 1 then
			if i == 1 then p 'Оплавленные скалы дышат жаром. Стоит притормозить и гусеницы зальет расплавленная порода.';
			elseif i == 2 then p 'Вулкан поблизости вспыхнул и выкинул тучу пепла. Куски шлака застучали по моей обшивке.';
			elseif i == 3 then p 'Отклонение от курса, обогнул ручей лавы.';
			end;
		elseif global_var_random_planet == 2 then
			if i == 1 then p 'Хрустя промороженным гравием, я еду по этой пустынной планете.';
			elseif i == 2 then p 'Сцепление с поверхностью на леднике становится недостаточным. Выжигаю хеллборами себе путь. Лед испаряется и образует туман, которого не было здесь миллионы лет.';
			elseif i == 3 then p 'Высокие ледяные колонны на моем пути. От вибрации вызванной моим движением они начинают рассыпаться. Мою броню заносит снегом.';
			end;
		elseif global_var_random_planet == 3 then
			if i == 1 then p 'Я еду сквозь лес. Стволы гигантских грибов разлетаются в стороны или превращаются в месиво под моими гусеницами.';
			elseif i == 2 then p 'Я выехал на небольшую полянку. Вокруг густой грибной лес.';
			elseif i == 3 then p 'Я расплескиваю воду мелкого болотца. Гигантские грибы здесь растут особенно густо, но это не препятствие для меня.';
			end;
		elseif global_var_random_planet == 4 then
			if i == 1 then p 'Ветер бросает песок на мой корпус, я еду по этой пустынной планете.';
			elseif i == 2 then p 'Поднятый мною песок забивается в турбины, переключаюсь на скорость ниже.';
			elseif i == 3 then p 'Засекаю высокое содержание металлов, но это всего-лишь скала из магнитного железняка. Еду дальше.';
			end;
		end;
	end;
	click = function(s, x, y)
	--ограничиваем ход одной клеткой в сторону
		if bolo_y < (y + 50) and y < (bolo_y + 100) and bolo_x < (x + 50) and x < (bolo_x + 100) then 
	--закрашиваем покиную клетку
			field = field..'box:50x50,gray,16@'..bolo_x..','..bolo_y..';';
	--получаем новые координаты
			bolo_x = math.ceil(x/50 - 1)*50;
			bolo_y = math.ceil(y/50 - 1)*50;
	--закрашиваем клетку по новым координатам
			field_bolo = field..'gfx/Bolo.png@'..bolo_x..','..bolo_y..';';
			global_var_bolo_count = global_var_bolo_count - 1;
			if global_var_bolo_count == 0 then
				p 'Время отведенное на исследование этой планеты истекло. Инициирую процедуру возвращения.';
				walk 'backoff';
			end;
			if global_var_random_planet == 1 and pl.where ~= 'Limbo' and pl.where ~= 'Omicron_Persey' then
				p 'Жар наносит урон моим системам.';
				global_var_bolo_life = global_var_bolo_life - rnd(15);
				if global_var_bolo_life < 16 then
					p 'Мой ресурс практически исчерпан. Инициирую экстренную эвакуацию.';
					walk 'backoff';
				end;
			end;
		end;
	--выдаем предмет если нашли желтую клетку, значение в массиве которой равно 1
		if array[math.floor(bolo_y/50 + 1)][math.floor(bolo_x/50 + 1)] == 1 then
			bolo_trophy();
			array[math.floor(bolo_y/50 + 1)][math.floor(bolo_x/50 + 1)] = 0;
		end;
		global_var_one = 1;
		return true;
	end;
	way = {vroom('Вернуться на корабль', 'backoff')};
	exit = function(s, t)
		if t == backoff then
			change_pl('pl');
			inv():cat(objs(bolo));
			objs(bolo):zap();
			inv():del(status_bolo);
			bolo_x = 350;
			bolo_y = 150;
			objs():del('bolo_beacon');
			set_music('bgm/cosmos-travelling.mod');
			return false;
		end;
	end;
};

backoff = room {
	nam = 'Заглушка';
};

bolo_trophy = function()
	global_var_bolo_rnd = rnd(15);
	if global_var_bolo_rnd == 1 and not seen (laser_crystals, pl) and not have 'laser_crystals' then
		take 'laser_crystals';
		p 'Сенсоры обнаружили что-то. Это лазерные кристаллы. Неплохая находка.';
	elseif global_var_bolo_rnd == 2 and not seen (coolant, pl) and not have 'coolant' then
		take 'coolant';
		p 'Сенсоры обнаружили что-то. Это хладагент. Неплохая находка.';
	elseif global_var_bolo_rnd == 3 and not seen (palladium, pl) and not have 'palladium' then
		take 'palladium';
		p 'Сенсоры обнаружили что-то. Это палладий. Неплохая находка.';
	elseif global_var_bolo_rnd == 4 and not seen (nanoprocessors, pl) and not have 'nanoprocessors' then
		take 'nanoprocessors';
		p 'Сенсоры обнаружили что-то. Это нанопроцессоры. Неплохая находка.';
	elseif global_var_bolo_rnd == 5 then
		global_var_torpedo = global_var_torpedo + rnd(3);
		p 'Сенсоры обнаружили что-то. Это остатки разведчика Федерации. Внутри нашлась пара фотонных торпед. Неплохо.';
	elseif global_var_bolo_rnd == 6 and not seen (adamantium, pl) and not have 'adamantium' then
		take 'adamantium';
		p 'Сенсоры обнаружили что-то. Это адамантиум. Отличная находка.';
	elseif global_var_bolo_rnd == 7 and not seen (kryptonite, pl) and not have 'kryptonite' then
		take 'kryptonite';
		p 'Сенсоры обнаружили что-то. Это криптонит. Отличная находка.';
	elseif global_var_bolo_rnd == 8 and not seen (analyzer, pl) and not have 'analyzer' then
		take 'analyzer';
		p 'Сенсоры обнаружили что-то. Это вероятностный анализатор. Интересная находка.';
	elseif global_var_bolo_rnd == 9 and not seen (unobtainium, pl) and not have 'unobtainium' then
		take 'unobtainium';
		p 'Сенсоры обнаружили что-то. Это очень редкий анобтаниум. Загрузил в грузовой отсек.';
	elseif global_var_bolo_rnd == 9 and not seen (red_mercury, pl) and not have 'red_mercury' then
		take 'red_mercury';
		p 'Сенсоры обнаружили что-то. Это кристаллы соли красной ртути. Загрузил в грузовой отсек.';
	elseif global_var_bolo_rnd >= 10 then
		p 'Обнаружен противник. Это шагоход Доваков.';
		if rnd(2) == 1 then p 'Он атакует меня ракетами. Я выстреливаю тепловую обманку, включаю антигравитаторы и ускоряюсь до 200км/ч.';
		else p 'Он стреляет в меня лазерами. Я запускаю дымовую завесу, включаю антигравитаторы и ускоряюсь до 200км/ч.'; end;
		if rnd(2) == 1 then p 'Шагоход атакует снова, осколки моей брони летят в стороны.';
			global_var_bolo_life = global_var_bolo_life - rnd(15);
		else p 'Шагоход атакует снова, но удар пришелся вскользь.'; end;
		p ' Я отвечаю залпом хеллборов, корпус противника покосился и с треском упал. Несколько внутренних взрывов завершили дело. Продолжаю выполнение задания.';
--	else
--		p 'Сенсоры обнаружили что-то. Это просто мусор. Ничего ценного.';
	end;
end;


bolo_beacon = obj {
	nam = 'Маяк';
	act = function()
		if global_var_bolo_life < 20 then p 'Необходим ремонт. Моя боевая эффективность крайне ограничена.';
		else
			change_pl('bolo');
			inv():add(status_bolo);
			global_var_one = 1;
			set_music('bgm/tracks_of_harmony.mod');
--рисуем карту
		if pl.where == 'Limbo' then field = field..'gfx/limbo_surf.png@0,0';
		elseif pl.where == 'Omicron_Persey' then field = field..'gfx/trap.png@0,0';
		elseif global_var_random_planet == 1 then field = field..'gfx/lava.png@0,0';
		elseif global_var_random_planet == 2 then
			if rnd(2) == 1 then field = field..'gfx/froz.png@0,0';
			else field = field..'gfx/froz2.png@0,0'; end;
		elseif global_var_random_planet == 3 then 
			if rnd(2) == 1 then field = field..'gfx/mushroom.png@0,0';
			else field = field..'gfx/mushroom2.png@0,0'; end;
		elseif global_var_random_planet == 4 then
			if rnd(2) == 1 then field = field..'gfx/desert.png@0,0';
			else field = field..'gfx/desert2.png@0,0'; end;
		end;
		local a, b, x, y;
		x = 0;
		y = 0;
		field_bolo = field;
		for a = 1, 6 do
			array[a] = {};
			for b = 1, 15 do
				if rnd(25) == 1 then
					field = field..'gfx/attention.png@'..x..','..y..';';
					array[a][b] = 1;
				else
					array[a][b] = 0;
				end;
				x = x + 50;
			end;
			x = 0;
			y = y + 50;
		end;
		field_bolo = field..'gfx/Bolo.png@'..bolo_x..','..bolo_y..';';
		end;
	end;
	dsc = function()
		if here() == Limbo then p 'Зафиксирована странная электромагнитная активность с выжженной планеты, {высадить Боло}?';
		elseif here() == Omicron_Persey then p 'Зафиксирована странная электромагнитная активность с одной из крупных лун газового гиганта, {высадить Боло}?';
		elseif global_var_random_planet == 1 then p 'Зафиксирована странная электромагнитная активность с вулканической планеты, {высадить Боло}?';
		elseif global_var_random_planet == 2 then p 'Зафиксирована странная электромагнитная активность с внешней планеты системы, {высадить Боло}?';
		elseif global_var_random_planet == 3 then p 'Зафиксирована странная электромагнитная активность с планеты в зоне жизни, {высадить Боло}?';
		elseif global_var_random_planet == 4 then p 'Зафиксирована странная электромагнитная активность с пустынной планеты, {высадить Боло}?';
		end;
	end;
};
