repair_droid_dlg = dlg {
	nam = 'Ремонтный дроид';
	pic = 'gfx/repair_droid.png';
	enter = function()
		local o,u;
		if global_var_repair_droid_life > 90 then
			p '- Ремонтный дроид готов выполнять приказания, - четко отрапортовал новенький и блестящий смазкой бортовой ремонтный дроид К-серии.';
		elseif global_var_repair_droid_life > 60 then
			p '- Ремонтный дроид готов выполнять приказания, - отрапортовал слегка изношенный бортовой ремонтный дроид К-серии.';
		elseif global_var_repair_droid_life > 30 then
			p '- Ремонтный дроид готов выполнять приказания, - проскрипел сильно изношенный бортовой ремонтный дроид К-серии.';
		elseif global_var_repair_droid_life > 0 then
			p '- Ремонтный дроид гггг-гготов выполнять приказания, - заикаясь отрапортовал полностью изношенный бортовой ремонтный дроид К-серии.';
		elseif global_var_repair_droid_life <= 0 then
			p 'Дроид кажется неисправен.';
			set_sound('bgm/127169__mikobuntu__total-malfunct.wav', '0', '1');
		end;
		if global_var_bolo_life < 100 then pon 'bolo'; else poff 'bolo'; end;
		poff('superlaser', 'cool', 'quark_bomb', 'laser');
		if have 'chip' and have 'adamantium' and have 'laser_crystals' and have 'red_mercury' and not have 'superlaser' then pon 'superlaser'; end;
		if have 'palladium' or have 'adamantium' or have 'kryptonite' or have 'unobtainium' and global_var_reactor < 8 then pon 'cool'; end;
		if have 'red_mercury' and have 'unobtainium' and not have 'quark_bomb' then pon 'quark_bomb'; end;
		if have 'laser_crystals' and global_var_lasers_mk < 3 then pon 'laser'; end;
		if have 'nanoprocessors' and global_var_repair_droid_life < 100 then pon 'repair'; end;
	end;
	phr = {
		{always = true, 'Кораблю нужен ремонт, вперед за работу!', '- ', code[[if global_var_life == 100 then p 'Корабль не нуждается в ремонте.'; elseif global_var_repair_droid_life <= 0 then p 'Отказ систем. Выключение.'; back(); else p 'Приказ понят. Приступаю к выполнению.'; global_var_repair_droid_life = global_var_repair_droid_life - rnd(20); global_var_life = global_var_life + rnd(20); if global_var_life > 100 then global_var_life = 100; end; end;]]};
		{tag = 'bolo', false, 'Отремонтируй наш танк "Боло".', code[[if global_var_repair_droid_life <= 0 then p '- Отказ систем. Выключение.'; back(); else p '- Приказ понят. Приступаю к выполнению.'; global_var_repair_droid_life = global_var_repair_droid_life - rnd(50); global_var_bolo_life = 100; end;]]};
		{tag = 'superlaser', false, 'Собери суперлазер!', code[[
			if have 'chip' and have 'adamantium' and have 'laser_crystals' and have 'red_mercury' then
				p 'Ремонтный дроид долго и упорно долбил гиперключом микросхему. Добравшись до внутренностей, он вынул оттуда несколько ламп. После чего при помощи лазерной сварки сварил угловатую конструкцию из адамантиума. Вставил туда лампы и лазерные кристаллы. Залил в специальную емкость красную ртуть, подключил кабель мегаваттного питания и проскрипел: "Суперлазер готов!"';
				inv():del(chip);
				inv():del(adamantium);
				inv():del(laser_crystals);
				inv():del(red_mercury);
				o,u = inv():srch('arms');
				putto('superlaser', inv(), u + 1);
			else p '- Нет необходимых материалов.';
			end;]]};
		{tag = 'cool', false, 'Реактору необходимо дополнительное охлаждение.', code[[
			if have 'adamantium' and global_var_reactor < 8 then
				global_var_reactor = global_var_reactor + rnd(3);
				inv():del(adamantium);
				p ('Ремонтный дроид прихватил груз адамантиума и исчез в люке реакторного отсека. Через некоторое время контрольные приборы зафиксировали снижение температуры. Похоже что дополнительная изоляция помогла.');
				pon 'cool';
			elseif have 'kryptonite' and global_var_reactor < 8 then
				global_var_reactor = global_var_reactor + rnd(3);
				inv():del(kryptonite);
				p ('Ремонтный дроид прихватил груз криптонита и исчез в люке реакторного отсека. Через некоторое время контрольные приборы зафиксировали снижение температуры. Похоже что дополнительная изоляция помогла.');
				pon 'cool';
			elseif have 'unobtainium' and global_var_reactor < 8 then
				global_var_reactor = global_var_reactor + rnd(3);
				inv():del(unobtainium);
				p ('Ремонтный дроид прихватил груз анобтаниума и исчез в люке реакторного отсека. Через некоторое время контрольные приборы зафиксировали снижение температуры. Похоже что дополнительная изоляция помогла.');
				pon 'cool';
			elseif have 'palladium' and global_var_reactor < 8 then
				global_var_reactor = global_var_reactor + rnd(3);
				inv():del(palladium);
				p ('Ремонтный дроид прихватил груз палладия и исчез в люке реакторного отсека. Через некоторое время контрольные приборы зафиксировали снижение температуры. Похоже что дополнительная изоляция помогла.');
				pon 'cool';
			else
				p 'Нет необходимых материалов.';
			end;]]};
		{tag = 'quark_bomb', false, 'Собери кварковую бомбу.', code[[
			if have 'red_mercury' and have 'unobtainium' and not have 'quark_bomb' then
				o,u = inv():srch('droids');
				putto('quark_bomb', inv(), u);
				inv():del(red_mercury);
				inv():del(unobtainium);
				p 'Ремонтный дроид прихватил груз анобтаниума и красной ртути и удалился в мастерскую. Через некоторое время он вернулся с готовой кварковой бомбой.';
			else
				p 'Нет необходимых материалов.';
			end;]]};
		{tag = 'laser', false, 'Настрой наши лазерные батареи.', code[[
			if have 'laser_crystals' and global_var_lasers_mk < 3 then
				inv():del(laser_crystals);
				global_var_lasers_mk = global_var_lasers_mk + 1;
				p 'Ремонтный дроид прихватил лазерные кристаллы из трюма и удалился на орудийную палубу. Немного звонких металлических ударов и грохота от падения чего-то крупного и лазеры стали мощнее.';
			else
				p 'Нет необходимых материалов.';
			end;]]};
		{always = true, 'Доложи о своем состоянии.', '- ', code[[if global_var_repair_droid_life > 60 then p 'Системы в норме, готов выполнять задание.'; elseif global_var_repair_droid_life > 30 then p 'Некоторые системы нуждаются в обслуживании, функциональность ограничена.'; else p 'Отказ некоторых систем. Срочно необходимо техническое обслуживание.'; end;]]};
		{tag = 'repair', false, 'Активируй авторемонт.', code[[
			if have 'nanoprocessors' and global_var_repair_droid_life < 100 then
				inv():del(nanoprocessors);
				global_var_repair_droid_life = global_var_repair_droid_life + rnd(50);
				p 'Скрипящий ремонтный дроид забрал нанопроцессоры из трюма, открыл свою панель управления, рывком выдернул несколько сгоревших модулей и вставил нанопроцессоры. Так-то лучше.';
			else
				p 'Нет необходимых материалов.';
			end;]]};
		{always = true, 'Отмена.', nil, [[back();]]};
	};
};

adm_dlg = dlg {
	nam = 'Переговоры с адмиралом';
	pic = 'gfx/Space_station.png';
	enter = 'Капитан Киркунов нажал одну из клавиш на подлокотнике капитанского кресла. На экране рубки появилось изображение обеспокоенного адмирала Краснова.^- Наконец-то. Капитан, я отправляю вам последние данные. Помните, колония и я можем рассчитывать только на вас. И надеюсь не нужно мне говорить, как важна ваша миссия для Терры. Без этих данных нападение Доваков окажется полной неожиданностью. Здесь данные разведки, техническая информация об используемом ими вооружения, расовые особенности и прочее. Есть вопросы, капитан?';
	phr = {
		{'Почему был выбран именно мой корабль?', '- В системе больше нет межзвездных кораблей, за исключением пары рудовозов. Так что вы наша единственная надежда. Не подведите, капитан.', [[pon 'safe';]]};
		{'Почему вы не отправили сообщение по гиперсвязи?', '- Связь каким-то образом глушится. И эта информация тоже должна быть у земного командования, и желательно до того как волна вторжения захлестнет наши миры.'};
		{'Куда я должен доставить данные?', '- На базу космофлота на Центавре. Там сейчас находится седьмой флот. Это самая большая наша военная сила в этом секторе. Это достаточно далеко и вам нужно будет сделать несколько остановок для корректирования курса в неизвестных системах по пути. Надеюсь эта космическая саранча не опередила нас.'};
		{'Почему Доваки все-таки напали?', '- Мы десятки лет мирно сотрудничали с расой Доваков. Они освоили пару десятков систем и абсолютно не проявляли интереса к освоению новых. Более того даже продали нам ценные данные по, например, этой планете и были не против колонизации землянами. Пару лет назад отношения ухудшились. Они не принимали наших торговцев и выслали наших послов с их планет. А вот теперь открыто напали. Цикл миграции или что-то вроде этого, в информации, которую вы везёте есть отчет ксенологов. Простому военному, как я, понятно только одно. Сейчас они враги и точка.'};
		{tag = 'safe', false, 'Но значит вы остаетесь беззащитными?', '- У нас есть сеть спутников и орбитальная станция. Население сейчас эвакуируется в обширную сеть пещер в южных каньонах. Не беспокойтесь за нас, капитан. Когда-то я партизанил на лунах Нордхейма и мои руки еще помнят как держать бластер. Мы продержимся. Главное чтобы было чего дожидаться. А для этого вы должны добраться до наших.'};
		{'У меня больше нет вопросов.', '- Тогда что вы еще тут делаете? Вперед, пока не подошли основные силы противника.^^С этими словами адмирал отключился.^- Капитан. Я рассчитал курс. Мы можем прыгать в любой момент, - сказал старпом Морзе.', [[walk(post);]]};
	};
};

cap_dlg = dlg {
	nam = 'Переговоры с капитаном';
	pic = 'gfx/cap_dlg.png';
	enter = '- Капитан, входящее сообщение, - доложил старпом. Киркунов кивнул и нажал одну из клавиш на подлокотнике капитанского кресла. На экране рубки появилось изображение мрачного бородатого человеческого лица.^- Наконец-то. Капитан Киркунов, как я вижу! - С непонятным торжеством в голосе произнес незнакомец.';
	phr = {
		{tag = 'on', 'С кем имею честь?', '- Неважно, - грубо прервал его бородач, - слушай меня внимательно, у меня мало времени и у тебя тоже, временная аномалия скоро закроется.', [[pon 'otv';]]};
		{tag = 'otv', false, 'Бросьте ваши загадки. Кто вы и откуда вы меня знаете?', '- Поймешь немного попозже, - усмехнулся неизвестный.'};
		{tag = 'otv', false, 'Говорите. Что вы хотите мне рассказать?', '- Во-первых, хватит бродить по галактике, ты обязательно должен доставить данные в штаб флота на Центавре. Иначе очень скоро станет поздно. И запасись оружием, да побольше. Ха, кажется, мое время вышло. Удачи тебе, капитан. Она тебе понадобится, - с этими словами сигнал пропал и экран покрылся помехами.', [[pon 'end'; poff 'otv';]]};
		{tag = 'end', false, 'Ну и хамло. Как ты думаешь, кто это был, Морзе?', 'Морзе странно взглянул на капитана и сказал: Если бы вы не находились рядом со мной на мостике, то я бы сказал что это были вы. Только немного обтрепанный и с ... - Морзе жестом показал бороду.^Капитан Киркунов в ответ подозрительно взглянул на стапома, помолчал и произнес: Кажется, нам стоит поторопиться.', code[[objs(from()):del('station'); pon 'on'; back();]]};
	};
};

comp_dlg = dlg {
	nam = 'Видеосвязь';
	pic = 'gfx/comp_dlg.png';
	enter = '- Капитан, входящее сообщение, - доложил старпом. Киркунов кивнул и нажал одну из клавиш на подлокотнике капитанского кресла. На экране рубки появилось какое-то схематическое абстрактное изображение.^- Приветствие. Ваш сигнал мне незнаком. Грузовоз или заказчик? Или нарушитель, как последние несколько сотен кораблей? Тогда у меня еще остались термоядерные ракеты для вас.';
	phr = {
		{tag = 'on', 'Хм, нет, не нарушитель, я капитан Киркунов и хотел бы заказать или купить пару вещиц.', '- Замечательно. Я так давного этого ждал, что на складе практически не осталось ничего пригодного для эксплуатации. Боюсь электроника просто пришла в негодность.', [[pon 'what'; poff 'on';]]};
		{tag = 'on', 'Хм, нет, не нарушитель, я капитан грузового судна "Созвездие".', '- Тогда вы должны передать мне опознавательный код.', [[pon 'otv'; poff 'on'; poff 'exit';]]};
		{tag = 'on', 'Нарушитель чего?', '- Нарушители покушаются на частную собственность корпорации, у меня есть строгие инструкции по поводу отношения к нарушителям.'};
		{tag = 'on', 'Кто вы?', '- Я искуственный интеллект третьего класса, установленный на этой фабрике для управления и присмотра за процессом. К сожалению последние пару сотен оборотов вокруг этой звезды меня не навещали заказчики или грузовые суда, привозящие ресурсы или забирающие продукцию.'};
		{tag = 'what', false, 'Хм, ладно, покажите что осталось.', '- Хорошо. Вот наш каталог.', [[pon 'kat'; pon 'exit';]]};
		{tag = 'otv', false, 'Хм, у меня нет такого кода.', '- Значит вы нарушитель и я должен послать вам пару термоядерных ракет, прощайте и удачи вам.', [[pon 'on'; global_var_life = 0; walk(end1);]]};
		{tag = 'kat', false, 'Купить абордажного дроида - 220K.', '-', code[[if have 'boarding_droid' then p 'У вас уже есть абордажный дроид' elseif global_var_credits < 220 then p 'У вас недостаточно кредитов.'; else local o,u; o,u = inv():srch('hold'); putto('boarding_droid', inv(), u); global_var_credits = global_var_credits - 220;  p 'Готово.'; end; pon 'kat';]]};
		{tag = 'kat', false, 'Купить дроида псионика - 250K.', '-', code[[if have 'psy_droid' then p 'У вас уже есть пси дроид' elseif global_var_credits < 250 then p 'У вас недостаточно кредитов.'; else local o,u; o,u = inv():srch('hold'); putto('psy_droid', inv(), u); global_var_credits = global_var_credits - 250;  p 'Готово.'; end; pon 'kat';]]};
		{tag = 'kat', false, 'Купить суперлазер - 500K.', '- ', [[if have 'superlaser' then p 'У вас уже есть суперлазер' elseif global_var_credits < 500 then p 'У вас недостаточно кредитов.'; else local o,u; o,u = inv():srch('arms'); putto('superlaser', inv(), (u + 1)); global_var_credits = global_var_credits - 500;  p 'Готово.'; end; pon 'kat';]]};
		{tag = 'kat', false, 'Купить фотонную торпеду - 50K.', '- ', code[[if global_var_credits < 50 then p 'У вас недостаточно кредитов.'; else global_var_torpedo = global_var_torpedo + 1; global_var_credits = global_var_credits - 50;  p 'Готово.'; end; pon 'kat';]]};
		{tag = 'kat', false, 'Купить ремонтных наноботов - 15K.', '- ', code[[if global_var_life == 100 then p 'Вы не нуждаетесь в ремонте'; elseif global_var_credits < 15 then p 'У вас недостаточно кредитов.'; elseif global_var_life > 95 then global_var_life = 100; global_var_credits = global_var_credits - 15; p 'Готово.'; elseif global_var_life < 96 then global_var_life = global_var_life + 5; global_var_credits = global_var_credits - 15; p 'Ресурс наноботов ограничен, если вы нуждаетесь в дальнейшем ремонте, то купите еще.'; end; pon 'kat';]]};
		{tag = 'exit', 'Прервать сеанс связи.', nil, code[[objs(from()):del('station'); pon 'on'; poff 'kat'; back();]]};
	};
};

factory_dlg = dlg {
	nam = 'Торговая станция';
	pic = 'gfx/factory_dlg.png';
	enter = function()
		p 'Вас приветствует автоматический торговый пост компании Цзерка. Мы лучшие в этом и соседних секторах галактики. Чего вы желаете?';
		poff ('lasers', 'torpedos', 'droid', 'reactor', 'nanoprocessors', 'chip', 'laser_crystals', 'transmitter', 'coolant', 'palladium', 'quark_bomb', 'analyzer', 'unobtainium', 'mental_communicator', 'adamantium', 'kryptonite', 'red_mercury', 'hyperradio');
		if global_var_factory_rnd == 1 then pon 'lasers';
		elseif global_var_factory_rnd == 2 then pon 'torpedos';
		elseif global_var_factory_rnd == 3 then	pon 'droid';
		elseif global_var_factory_rnd == 4 then	pon 'reactor';
		end;
		if have 'nanoprocessors' then pon 'nanoprocessors'; end;
		if have 'chip' then pon 'chip'; end;
		if have 'laser_crystals' then pon 'laser_crystals'; end;
		if have 'transmitter' then pon 'transmitter'; end;
		if have 'coolant' then pon 'coolant'; end;
		if have 'palladium' then pon 'palladium'; end;
		if have 'quark_bomb' then pon 'quark_bomb'; end;
		if have 'analyzer' then pon 'analyzer'; end;
		if have 'unobtainium' then pon 'unobtainium'; end;
		if have 'mental_communicator' then pon 'mental_communicator'; end;
		if have 'adamantium' then pon 'adamantium'; end;
		if have 'kryptonite' then pon 'kryptonite'; end;
		if have 'red_mercury' then pon 'red_mercury'; end;
		if have 'hyperradio' then pon 'hyperradio'; end;
	end;
	phr = {
		{always = true, 'Ремонт корабля - 5%. Стоимость 20K', '- ', code[[if global_var_life == 100 then p 'Вы не нуждаетесь в ремонте'; elseif global_var_credits < 20 then p 'У вас недостаточно кредитов.'; elseif global_var_life > 95 then global_var_life = 100; global_var_credits = global_var_credits - 20; p 'Готово.'; elseif global_var_life < 96 then global_var_life = global_var_life + 5; global_var_credits = global_var_credits - 20; p 'Готово.'; end;]]};
		{tag = 'lasers', false, 'Улучшить системы лазерного наведения - 200K', '- ', code[[if global_var_lasers_mk == 3 then p 'У вас уже установлена самая лучшая аппаратура.'; elseif global_var_credits < 200 then p 'У вас недостаточно кредитов.'; else global_var_lasers_mk = global_var_lasers_mk + 1; global_var_credits = global_var_credits - 200; p 'Готово.'; end; pon 'lasers';]]};
		{tag = 'torpedos', false, 'Купить фотонную торпеду - 40K', '- ', code[[if global_var_credits < 40 then p 'У вас недостаточно кредитов.'; else global_var_torpedo = global_var_torpedo + 1; global_var_credits = global_var_credits - 40;  p 'Готово.'; end; pon 'torpedos';]]};
		{tag = 'torpedos', false, 'Купить кварковую бомбу - 120K', '- ', code[[if have 'quark_bomb' then p 'У вас уже есть кварковая бомба'; elseif global_var_credits < 120 then p 'У вас недостаточно кредитов.'; else local o,u; o,u = inv():srch('droids'); putto('quark_bomb', inv(), u); global_var_credits = global_var_credits - 120;  p 'Готово.'; end; pon 'torpedos';]]};
		{tag = 'torpedos', false, 'Продать фотонную торпеду - 20К', '- ', code[[if global_var_torpedo == 0 then p 'У вас нет фотонных торпед.'; else global_var_torpedo = global_var_torpedo - 1; global_var_credits = global_var_credits + 20;  p 'Готово.'; end; pon 'torpedos';]]};
		{tag = 'droid', false, 'Купить абордажного дроида - 200K.', '-', code[[if have 'boarding_droid' then p 'У вас уже есть абордажный дроид' elseif global_var_credits < 200 then p 'У вас недостаточно кредитов.'; else local o,u; o,u = inv():srch('hold'); putto('boarding_droid', inv(), u); global_var_credits = global_var_credits - 200;  p 'Готово.'; end; pon 'droid';]]};
		{tag = 'droid', false, 'Купить ремонтного дроида - 200K.', '-', code[[if global_var_repair_droid_life > 60 then p 'У вас уже есть исправный ремонтный дроид' elseif global_var_credits < 200 then p 'У вас недостаточно кредитов.'; else global_var_repair_droid_life = 100; global_var_credits = global_var_credits - 200;  p 'Готово.'; end; pon 'droid';]]};
		{tag = 'reactor', false, 'Охладить реактор - 20K.', code[[if global_var_reactor > 8 then p '- У вас все в порядке с реактором' elseif global_var_credits < 20 then p '- У вас недостаточно кредитов.'; else global_var_reactor = global_var_reactor + 1; global_var_credits = global_var_credits - 20;  p '- Готово.'; end; pon 'reactor';]]};
		{tag = 'reactor', false, 'Купить хладагент - 100K.', code[[if have 'coolant' then p '- У вас уже есть охладитель' elseif global_var_credits < 100 then p '- У вас недостаточно кредитов.'; else take 'coolant'; global_var_credits = global_var_credits - 100;  p '- Готово.'; end; pon 'reactor';]]};
		{tag = 'laser_crystals', false, 'Продать кристаллы - 100K', code[[if have 'laser_crystals' then p '- Готово.'; global_var_credits = global_var_credits + 100; inv():del(laser_crystals); else p '- У вас нет этих кристаллов.'; end;]]};
		{tag = 'nanoprocessors', false, 'Продать нанопроцессоры - 70K.', code[[if have 'nanoprocessors' then p '- Готово.'; global_var_credits = global_var_credits + 70; inv():del(nanoprocessors); else p '- У вас нет нанопроцессоров.'; end;]]};
		{tag = 'coolant', false, 'Продать хладагент - 50K.', code[[if have 'coolant' then p '- Готово.'; global_var_credits = global_var_credits + 50; inv():del(coolant); else p '- У вас нет охладителя.'; end;]]};
		{tag = 'chip', false, 'Продать микросхему - 25K.', code[[if have 'chip' then p '- Готово.'; global_var_credits = global_var_credits + 25; inv():del(chip); else p '- У вас нет микросхемы.'; end;]]};
		{tag = 'palladium', false, 'Продать палладий - 100K.', code[[if have 'palladium' then p '- Готово.'; global_var_credits = global_var_credits + 100; inv():del(palladium); else p '- У вас нет палладия.'; end;]]};
		{tag = 'unobtainium', false, 'Продать анобтаниум - 120K.', code[[if have 'unobtainium' then p '- Готово.'; global_var_credits = global_var_credits + 120; inv():del(unobtainium); else p '- У вас нет анобтаниума.'; end;]]};
		{tag = 'transmitter', false, 'Продать передатчик "свой-чужой" - 75K.', '- Готово.', code[[global_var_credits = global_var_credits + 75; inv():del(transmitter);]]};
		{tag = 'analyzer', false, 'Продать вероятностный анализатор - 30K.', '- Готово.', code[[global_var_credits = global_var_credits + 30; inv():del(analyzer);]]};
		{tag = 'quark_bomb', false, 'Продать кварковую бомбу - 60K.', code[[if have 'quark_bomb' then p '- Готово.'; global_var_credits = global_var_credits + 60; inv():del(quark_bomb); else p '- У вас нет кварковой бомбы.'; end;]]};
		{tag = 'mental_communicator', false, 'Продать ментальный коммуникатор - 50K.', '- Готово.', code[[global_var_credits = global_var_credits + 50; inv():del(mental_communicator);]]};
		{tag = 'adamantium', false, 'Продать адамантиум - 130K.', code[[if have 'adamantium' then p '- Готово.'; global_var_credits = global_var_credits + 130; inv():del(adamantium); else p '- У вас нет адамантиума.'; end;]]};
		{tag = 'kryptonite', false, 'Продать криптонит - 80K.', code[[if have 'kryptonite' then p '- Готово.'; global_var_credits = global_var_credits + 80; inv():del(kryptonite); else p '- У вас нет криптонита.'; end;]]};
		{tag = 'red_mercury', false, 'Продать красную ртуть - 100K.', code[[if have 'red_mercury' then p '- Готово.'; global_var_credits = global_var_credits + 100; inv():del(red_mercury); else p '- У вас нет красной ртути.'; end;]]};
		{tag = 'hyperradio', false, 'Продать гипер-радио - 40K.', '- Готово.', code[[global_var_credits = global_var_credits + 50; inv():del(hyperradio);]]};
		{always = true, 'Прервать сеанс связи.', nil, [[objs(from()):del('station'); back();]]};
	};
};

customs_dlg = dlg {
	nam = 'Таможенный контроль';
	pic = 'gfx/customs_dlg.png';
	enter = '- Таможня, - грубо рявкнул насекомовидный ночной кошмар, - чего везете и куда? Говорить быстро!';
	phr = {
		{'Мы мирная исследовательская экспедиция.', '- Ну-ну, а столько пушек вам зачем?', [[pon 'research';]]};
		{'Мы везем важные сведения.', '- Ну-ну, давай тогда выкладывай!', [[pon 'data';]]};
		{tag = 'on', 'Мы хотим уплатить таможенный сбор, сколько?', '- ', code[[global_var_customs_rnd = rnd(30)+20; p ('О, сразу видно делового человека. С тебя ', global_var_customs_rnd, 'K и можешь лететь куда хочешь, друг.'); pon 'what';]]};
		{tag = 'on', 'Да не ваше вообще дело.', '- Ну-ну, тогда давай до свидания! Огонь по чужаку!', [[pon 'on'; global_var_life = 0; walk(end1);]]};
		{tag = 'research', false, 'Только для самообороны!', '- Так я и поверил. Ну-ну.'};
		{tag = 'data', false, 'Не уверен, что могу их доверить вам.', '- Тогда плати таможенный сбор как все и проваливай, чужак.'};
		{tag = 'what', false, 'Конечно я заплачу. Принимайте.', '- ', code[[if global_var_credits < global_var_customs_rnd then p 'Э, надуть меня пытаешься, у тебя не хватает!'; pon 'but'; else p 'Совсем другое дело, счастливого пути, чужак.'; global_var_credits = global_var_credits - global_var_customs_rnd; ways(Salamander):enable_all(); objs(Salamander):del('customs'); pon 'on'; back(); end;]]};
		{tag = 'what', false, 'Сколько-сколько?', '- ', code[[global_var_customs_rnd = rnd(20); p ('Тебя не проведешь, - Кисло произнес таможенник, - с тебя ', global_var_customs_rnd, 'K и можешь лететь куда хочешь, товарищ.'); pon 'good'; poff 'what';]]};
		{tag = 'but', false, 'Но это все что у нас есть.', '- Эх, какой я сегодня добрый. Давай что есть. Но смотри, не шатайся просто так по Саламандре, мы тут не любим всяких попрошаек.', code[[global_var_credits = 0; ways(Salamander):enable_all(); objs(Salamander):del('customs'); pon 'on'; back();]]};
		{tag = 'good', false, 'Совсем другое дело.', '- ', code[[if global_var_credits < global_var_customs_rnd then p 'Э, надуть меня пытаешься, у тебя не хватает!'; pon 'but'; else p 'Давай уже проваливай. И смотри, не шатайся просто так по Саламандре, мы тут не любим всяких умников.'; global_var_credits = global_var_credits - global_var_customs_rnd; ways(Salamander):enable_all(); objs(Salamander):del('customs'); if global_var_reactor < 4 then objs(Salamander):enable('wait'); end; pon 'on'; back(); end;]]};
	};
};

Emerson_dlg = dlg {
	nam = 'Видеосвязь';
	pic = 'gfx/Emerson.png';
	enter = '- Капитан, входящее сообщение, - доложил старпом. Киркунов кивнул и нажал одну из клавиш на подлокотнике капитанского кресла. ^- Корабль Федерации, вызываю корабль Федерации! О, здравствуйте капитан. Я представляю силы самообороны системы Эмерсона. Капитан, вы должны помочь мне. Федерация отозвала все свои боевые корабли из системы, потом прошел слух о нападении какой-то агрессивной расы. Вся система в панике, кто может тот улетает к Центавру. Рудокопы прячутся на своих астероидах. У меня только станция обороны и несколько патрульных ботов.';
	phr = {
		{'Успокойтесь, командующий. Да, информация верна, ваша система находится на векторе атаки Доваков. Но вы должны взять себя в руки и организовать людей.', '- Отличный совет, капитан, только что-то он не помогает. Но хотя бы неопределенности стало поменьше. Вы нуждаетесь в чем-либо? Я вижу ваш корабль уже изрядно потрепан.', [[if global_var_repair_droid_life < 100 then pon 'repair'; end; if global_var_lasers_mk < 3 then pon 'laser'; end; if not have 'boarding_droid' then pon 'boarding_droid'; end; pon 'torpedos'; global_var_one = 1;]]};
		{tag = 'repair', false, 'Небольшой ремонт не помешал бы.', '- Отправляю к вам ремонтных дроидов, это все чем мы можем помочь. Удачи вам, капитан.', [[global_var_repair_droid_life = 100; objs(from()):del('emersons'); back();]]};
		{tag = 'torpedos', false, 'Несколько торпед помогли бы делу.', '- Отправляю к вам шлюпку с торпедами, это все чем мы можем помочь. Удачи вам, капитан.', [[global_var_torpedo = global_var_torpedo + 10; objs(from()):del('emersons'); back();]]};
		{tag = 'laser', false, 'Наши лазерные батареи повреждены.', '- Отправляю к вам шлюпку с запчастями, это все чем мы можем помочь. Удачи вам, капитан.', [[global_var_lasers_mk = global_var_lasers_mk + 1; objs(from()):del('emersons'); back();]]};
		{tag = 'boarding_droid', false, 'Нам бы пригодился абордажный дроид.', '- Отправляю к вам абордажного дроида, это все чем мы можем помочь. Удачи вам, капитан.', code[[local o,u; o,u = inv():srch('hold'); putto('boarding_droid', inv(), u); objs(from()):del('emersons'); back();]]};
	};
};

dealer_dlg = dlg {
	nam = 'Видеосвязь';
	pic = 'gfx/dealer_dlg.png';
	enter = function()
		p '- Капитан, входящее сообщение, - доложил старпом. Киркунов кивнул и нажал одну из клавиш на подлокотнике капитанского кресла. ^- Огромная благодарность вам, капитан. Мы уже не чаяли и спастись, как тут появились вы на сцене. Наша благодарность не имеет границ. Как же я могу вознаградить вас за помощь?';
		poff ('repair', 'laser', 'boarding_droid', 'coolant');
		if global_var_repair_droid_life < 100 then pon 'repair'; end;
		if global_var_lasers_mk < 3 then pon 'laser'; end;
		if not have 'boarding_droid' then pon 'boarding_droid'; end;
		if global_var_reactor < 5 and not have 'coolant' then pon 'coolant'; end;
	end;
	phr = {
		{tag = 'repair', false, 'Небольшой ремонт не помешал бы.', '- Отправляю к вам новых ремонтных дроидов, надеюсь это вам поможет. Удачи вам, капитан.', [[global_var_repair_droid_life = 100; objs(from()):del('dealer'); back();]]};
		{always = true, 'Несколько торпед помогли бы делу.', '- Отправляю к вам шлюпку с торпедами, надеюсь это вам поможет. Удачи вам, капитан.', [[global_var_torpedo = global_var_torpedo + rnd(5); objs(from()):del('dealer'); back();]]};
		{tag = 'laser', false, 'Наши лазерные батареи повреждены.', '- О, у нас есть то, что вам нужно, новые лазеры и системы наведения, надеюсь это вам поможет. Удачи вам, капитан.', [[global_var_lasers_mk = global_var_lasers_mk + 1; objs(from()):del('dealer'); back();]]};
		{tag = 'boarding_droid', false, 'Нам бы пригодился абордажный дроид.', '- Отправляю к вам абордажного дроида, надеюсь это вам поможет. Удачи вам, капитан.', code[[local o,u; o,u = inv():srch('hold'); putto('boarding_droid', inv(), u); objs(from()):del('dealer'); back();]]};
		{tag = 'coolant', false, 'Наш реактор перегрет.', '- Отправляю вам пару канистр отличного охладителя, надеюсь это вам поможет. Удачи вам, капитан.', [[take 'coolant'; objs(from()):del('dealer'); back();]]};
		{always = true, 'Немного наличных и мы в расчете.', '- Перевожу средства вам на счет, надеюсь это вам поможет. Удачи вам, капитан.', [[global_var_credits = global_var_credits + rnd(75); objs(from()):del('dealer'); back();]]};
		{always = true, 'Нам ничего не нужно, это наша работа.', '- Что же, тогда прощаюсь с вами. Удачи вам, капитан.', [[objs(from()):del('dealer'); back();]]};
	};
};

Secret_system_dlg = dlg {
	nam = 'Мысли';
	pic = 'gfx/secret_system.png';
	enter = 'Капитана окружал мрак, в нем только шепот.^- Эти создания потревожили нас. Они проскользнули сквозь щель в континууме. Нашли наше убежище.';
	phr = {
		{tag = 'on', 'Что, кто вы, где я?', '- Примитивная мыслительная деятельность. Слишком много шума.', [[pon 'silent';]]};
		{tag = 'on', 'Игнорировать шепот и собраться с мыслями.', '- Примитивная мыслительная деятельность. Пытается концентрироваться. Забавен.', [[pon 'fun'; poff 'on'; poff 'silent';]]};
		{tag = 'silent', false, 'Ответьте мне, черт возьми, - возопил капитан во тьму.', '- Он потревожил нас. Возмездие неминуемо.', [[objs(from()):del('random_jump'); pon 'on'; back();]]};
		{tag = 'fun', false, 'Забавен? Я капитан Киркунов, командир БКК "Созвездие".', '- Начал шуметь. Вернем его обратно. Верное решение.', [[objs(from()):del('random_jump'); pon 'on'; back();]]};
		{tag = 'fun', false, 'Продолжать игнорировать шепот и собраться с мыслями.', '- Он не так уж и плох. Обратимся к нему?', [[pon 'next'; poff 'fun';]]};
		{tag = 'next', false, 'Да, услышьте меня!', '- Неверный ответ.', [[objs(from()):del('random_jump'); pon 'on'; back();]]};
		{tag = 'next', false, 'Капитан предельно сконцентрирован на разжигании искры и удержании пламени.', '- Верный ответ.', [[global_var_life = 100; global_var_torpedo = global_var_torpedo + 5; objs(from()):del('random_jump'); pon 'on'; poff 'next'; back();]]};
	};
};

sphere_dlg = dlg {
	nam = 'Переговоры со сферой';
	pic = 'gfx/term1.png';
	enter = '- Капитан, входящее сообщение от сферы.';
	phr = {
		{tag = 'on', 'Хм, что это может означать?', '- Наш бортовой переводчик опознал язык как tlhIngan Hol, но соответствующие словари почему-то не установлены.', [[if have 'psy_droid' then p '^- tlhIngan maH! - Внезапно включился пси дроид.^- Что это значит, дроид? - Спросил Морзе, но пси дроид не отвечает.'; pon 'psy'; pon 'exit'; poff 'on'; elseif live 'slug' then p '^- Это старое наречие, внезапно произнес Слизень-пассажир, попробуйте tlhIngan maH!. Это приветствие этой расы.'; pon 'slug'; poff 'on'; else p 'А вот какой пароль мы не знаем. - заметил Морзе.'; end;]]};
		{tag = 'on', 'Хм, игнорировать сообщение. Летим дальше.', '- Как прикажете, капитан.', [[pon 'on'; back();]]};
		{tag = 'psy', false, 'Ну хорошо, пусть будет tlhIngan maH!', [[- HIja' или ghobe' - снова включился пси дроид.]], [[sphere_dlg.pic = 'gfx/term2.png'; pon 'next2'; poff 'exit';]]};
		{tag = 'slug', false, 'Ну хорошо, пусть будет tlhIngan maH!', [[Вопрос подразумевает ответ в виде HIja' или ghobe' - это Да или Нет, а вот вопроса я не понял, что-то про хороший день для чего-то. Боюсь на этом мой словарный запас исчерпан.]], [[sphere_dlg.pic = 'gfx/term2.png'; pon 'next2'; poff 'exit';]]};
		{tag = 'exit', false, 'Думаю не стоит играть с огнем, этой железке сотни лет и что творится в его электронных мозгах одному Файнеглу известно. Летим дальше.', '- Как прикажете, капитан.', [[pon 'on'; poff 'psy'; poff 'slug'; back();]]};
		{tag = 'next2', false, [[HIja']], 'Кажется, это был неверный ответ, навстречу "Созвездию" полетело множество ракет и лазерных лучей.', [[walk(end1);]]};
		{tag = 'next2', false, [[ghobe']], 'Новый вопрос. Попробовать ответить наудачу?', [[sphere_dlg.pic = 'gfx/term3.png'; pon 'next3'; poff 'next2';]]};
		{tag = 'next3', false, [[HIja']], 'Сфера отключилась и больше не отвечает на запросы.', [[pon 'on'; poff 'next3'; back();]]};
		{tag = 'next3', false, [[ghobe']], 'И еще один вопрос. Надо что-то отвечать.', [[sphere_dlg.pic = 'gfx/term4.png'; pon 'next4'; poff 'next3';]]};
		{tag = 'next4', false, [[HIja']], 'Отлично, шлюз сферы открывается. Оказалось, что это полностью автоматическая ремонтная станция неизвестной цивилизации. Дроиды станции подлатали "Созвездие" и настроили лазеры.', code[[global_var_life = global_var_life + rnd(30); if global_var_life > 100 then global_var_life = 100; end; global_var_lasers_mk = global_var_lasers_mk + 1; if global_var_lasers_mk > 3 then global_var_lasers_mk = 3; end; global_var_reactor = global_var_reactor + rnd(3); if global_var_reactor > 8 then global_var_reactor = 8; end; local o,u; o,u = inv():srch('arms'); putto('superlaser', inv(), (u + 1)); pon 'on'; poff 'next4'; back();]]};
		{tag = 'next4', false, [[ghobe']], 'Сфера отключилась и больше не отвечает на запросы.', [[pon 'on'; poff 'next4'; back();]]};
	};
};

lexx_dlg = dlg {
	nam = 'Переговоры с Лекссом';
	pic = 'gfx/lexx.png';
	enter = 'На главном экране высветилось "Связь установлена", после чего проявилось изображение человека в красной форме. - Вы не корабль развлечений, нет? Ну типа космоборделя или что-то вроде этого? - Живо спросил человек.^- Я капитан Киркунов и это БКК "Созвездие". - Официально ответствовал Киркунов, несколько озадаченный вопросом. - Хотя иногда я сомневаюсь в этом.';
	phr = {
		{tag = 'on', 'Кто вы?', '- Я Стенли, капитан самого разрушительного оружия в двух вселенных! А координат ближайшей планеты развлечений не подкинете?', [[poff 'on'; if global_var_system_count > 10 then pon 'sal'; elseif global_var_system_count > 20 then pon 'dzeta'; elseif global_var_system_count > 42 then pon 'kequan'; else pon 'nope'; end;]]};
		{tag = 'on', 'Что это за корабль, биотехнологии?', '- Это Лексс, самое разрушительное оружие в двух вселенных и я его капитан. А координат ближайшей планеты развлечений не подкинете?', [[poff 'on'; if global_var_system_count > 10 then pon 'sal'; elseif global_var_system_count > 20 then pon 'dzeta'; elseif global_var_system_count > 42 then pon 'kequan'; else pon 'nope'; end;]]};
		{tag = 'sal', false, 'Недавно мы пролетали систему Саламандра, логово контрабандистов, притоны, наркотики, в общем небезопасное место.', '- О, кажется это то, что нужно. Лексс, принимай координаты и бери курс на Саламандру!^- Как прикажешь, Стенли. - Прозвучало откуда-то сверху. После чего сеанс связи прервался, а гигантское насекомое на хорошей скорости начало удаляться.', [[pon 'ext';]]};
		{tag = 'dzeta', false, 'Недавно мы пролетали систему Дзета Афродиты, там есть неплохой ресторан S.O.S.', '- О, кажется это то, что нужно. Лексс, принимай координаты и бери курс на Афродиту!^- Как прикажешь, Стенли. - Прозвучало откуда-то сверху. После чего сеанс связи прервался, а гигантское насекомое на хорошей скорости начало удаляться.', [[pon 'ext';]]};
		{tag = 'kequan', false, 'Недавно мы пролетали систему Ке Кван, обитатели системы не прочь выпить и могут выгнать спирт из любой органики.', '- О, кажется это то, что нужно. Лексс, принимай координаты и бери курс на Ке Кван!^- Как прикажешь, Стенли. - Прозвучало откуда-то сверху. После чего сеанс связи прервался, а гигантское насекомое на хорошей скорости начало удаляться.', [[pon 'ext';]]};
		{tag = 'nope', false, 'Нет, я не знаю координат подобных систем в поблизости.', '- Жаль, очень жаль. Лексс, взорви вот ту планету, может это развеселит меня.^- Как прикажешь, Стенли. - Прозвучало откуда-то сверху. После чего сеанс связи прервался, а гигантское насекомое выпустило фронт заряженных античастиц в сторону небольшого планетоида по поблизости. Планетод рассыпался на мелкие части.', [[pon 'ext1';]]};
		{tag = 'ext', false, 'И кого только не встретишь в космосе, верно Морзе?', '- Именно так, капитан.', [[pon 'on'; poff 'next4'; back();]]};
		{tag = 'ext1', false, 'Думаю нам не стоит здесь задерживаться, верно Морзе?', '- Именно так, капитан.', [[pon 'on'; poff 'next4'; back();]]};
	};
};

tavern_dlg = dlg {
	nam = 'Таверна';
	pic = 'gfx/tavern.png';
	enter = function()
		p 'Капитан вошел в таверну. Посетителей было немного. Троица рептилоидов в центре зала играла в какую игру с костями. Да еще, судя по многочисленным татуировкам и серьгам, старый пират в углу, пытающийся кажется, привлечь внимание капитана.';
		set_music('bgm/cantinam.xm');
		if live 'gizka' then
			pon 'gizka';
			p 'Также селкат у бара увлеченно рассматривает экран терминала.';
		else poff 'gizka'; end;
	end;
	phr = {
		{tag = 'on'};
		{always = true, 'Заказать выпить.', '- Все напитки проверены и почти не ядовиты для кислорододышащих, - приветственно прожужжал робобармен.', [[pjump 'drink';]]};
		{always = true, 'Подойти к пирату.', '- Капитан! Конечно же, я сразу тебя узнал, старый Пит разве забудет когда-нибудь ту гонку по малому радиусу, когда "Созвездие" преследовало нас. И так и не догнало, ха-ха.', [[pjump 'what'; pon 'what';]]};
		{always = true, 'Подойти к рептилоидам.', '- Эй, хочешь сыграть. Это кости, все умеют в них играть. Три кубика, кто больше наберет очков, тот и выиграл. Ставка 50 кредов.', [[pjump 'dice';]]};
		{always = true, 'Вернуться на "Созвездие" и отстыковаться.', '- И чего мы сюда вообще прилетели?', [[back();]]};
		{tag = 'gizka', false, 'Подойти к селкату.', '- Приветствую вас, капитан. Чем может вам помочь скромный ученый-биолог?', [[pjump 'otv'; pon 'otv';]]};
		{};
		{tag = 'what', 'Вы хотели что-то мне сообщить?', code[[if not path('Secret_system_2', from()) then p '- Еще как хотел, капитан! Очень ценные сведения, а точнее координаты. Координаты одной системы, в которой можно найти много интересного, но нужен хорошо вооруженный корабль. Путь туда опасен. Но понимаете, капитан, я не могу рассказать вам эти сведения просто так. Крейсер моей карьеры падает в черную дыру, да и корабль мой не очень. Дюзы прогорели, корпус в дырах. Мне бы немного финансов, чтобы прикупить небольшой грузовоз и я занялся бы честным фрахтом, да!'; pon 'howmany'; else p '- Нет, ничего нового.'; pjump 'on'; end;]]};
		{tag = 'howmany', false, 'И сколько?', code[[global_var_customs_rnd = rnd(100)+200; p ('- Да всего навсего ', global_var_customs_rnd, 'К кредитов.'); pon 'end'; pon 'howmany2'; pon 'yes';]]};
		{tag = 'howmany2', false, 'Сколько-сколько?', code[[global_var_customs_rnd = global_var_customs_rnd - rnd(200); p ('- Ой, я конечно хотел сказать ', global_var_customs_rnd, 'К кредитов.'); pon 'yes';]]};
		{tag = 'yes', false, 'Согласен.', code[[if global_var_credits < global_var_customs_rnd then p 'Э, стоять! Нехорошо поступаете, капитан. Сделку заключаете, а монет у вас нет.'; else p '- Хорошая сделка, капитан. Сбрасываю вам координаты.'; global_var_credits = global_var_credits - global_var_customs_rnd; ways(from()):add('Secret_system_2'); pjump 'on'; poff 'end'; poff 'howmany2'; end;]]};
		{tag = 'end', false, 'Нет, это меня не интересует.', '- Очень зря, капитан. Надумаете, возвращайтесь.', [[pjump 'on'; poff 'end'; poff 'howmany2'; poff 'yes';]]};
		{};
		{tag = 'otv', 'Откуда вы меня знаете и вы говорите, что вы биолог? У нас как раз есть одна биологическая проблема.', '- Смотрел репортаж про ваши победы по ТриВи, капитан. - Селкат кивнул в сторону терминала. - Проблема?', [[pon 'otv1';]]};
		{tag = 'otv1', false, 'Да, мой корабль заполонили орды грызунов-гизок и я не представляю что с этим можно сделать.', code[[if rnd(2) == 1 then p '- Пожалуй я смогу вам помочь, как насчет заплатить мне 50К за избавление?'; pon 'yes1'; pon 'ext'; else p '- Редкий вид? - С интересом произнес селкат. - Вы продадите их мне за 50К?'; pon 'yes2'; pon 'ext'; end;]]};
		{tag = 'yes1', false, 'Согласен, только избавьте меня от этих мелких тварей.', '- Я знаю метод собрать их в одном месте и соответвенно поймать. Скоро я займусь этим.', code[[if global_var_credits < 50 then p 'Стоп, капитан. У вас недостаточно средств чтобы заплатить мне.'; else lifeoff('gizka'); end; pjump 'on'; poff 'ext';]]};
		{tag = 'yes2', false, 'Мне жаль расставаться с такими редкими существами, но деньги мне нужнее.', '- Не беспокойтесь капитан, они в попали в хорошие руки.', code[[global_var_credits = global_var_credits + 50; lifeoff('gizka'); pjump 'on'; poff 'ext';]]};
		{tag = 'ext', false, 'Нет, это предложение меня не интересует.', '- Дело ваше, капитан. - Селкат кивнул и отвернулся.', [[pjump 'on'; pon 'gizka'; poff 'yes1'; poff 'yes2';]]};
		{tag = 'drink'};
		{always = true, 'Пангалактический грызлодёр - 10K', '- Он вышибет вам мозги кусочком лимона, в который завернут большой золотой кирпич!', [[if global_var_credits < 10 then p 'К сожалению на вашем счету недостаточно средств, попробуйте напитки попроще?'; elseif global_var_drink > 100 then p 'Что-то в глазах все поплыло и стойка стала стремительно приближаться. Через некоторое время капитан очнулся в медотсеке. Старпом неодобрительно смотрит на Киркунова.^- Если вы уже способны вертикально перемещаться, то я жду вас на мостике. А вообще можно было и меня с собой взять.'; global_var_drink = 0; back(); else global_var_drink = global_var_drink + rnd(100); global_var_credits = global_var_credits - 10; end;]]};
		{always = true, 'Пот сирианской пантеры - 6K.', '- "Пот Сирианской Пантеры" - гарантированный инфаркт в каждой бутылке!', [[if global_var_credits < 10 then p 'К сожалению на вашем счету недостаточно средств, попробуйте напитки попроще?'; elseif global_var_drink > 100 then p 'Что-то в глазах все поплыло и стойка стала стремительно приближаться. Через некоторое время капитан очнулся в медотсеке. Старпом неодобрительно смотрит на Киркунова.^- Если вы уже способны вертикально перемещаться, то я жду вас на мостике. А вообще можно было и меня с собой взять.'; global_var_drink = 0; back(); else global_var_drink = global_var_drink + rnd(50); global_var_credits = global_var_credits - 6; end;]]};
		{always = true, 'Наркопиво - 1K.', '- Дешево и сердито, выбор настоящих астронавтов!', [[if global_var_credits < 1 then p 'К сожалению на вашем счету нехватает даже на пиво.'; elseif global_var_drink > 100 then p 'Что-то в глазах все поплыло и стойка стала стремительно приближаться. Через некоторое время капитан очнулся в медотсеке. Старпом неодобрительно смотрит на Киркунова.^- Если вы уже способны вертикально перемещаться, то я жду вас на мостике. А вообще можно было и меня с собой взять.'; global_var_drink = 0; back(); else global_var_drink = global_var_drink + rnd(100); global_var_credits = global_var_credits - 1; end;]]};
		{always = true, 'Отойти от стойки.', '- Мы всегда будем рады увидеть вас снова.', [[pjump 'on';]]};
		{tag = 'dice'};
		{always = true, 'Бросить кости.', code[[
			if global_var_credits < 50 then p 'Стоять, нету кредов? Проваливай от нашего столика неудачник.'; pjump 'on';
			else
				dice();
			end;]]};
		{always = true, 'Забрать свои креды и отойти от столика.', '- Эй, захочешь сыграть, доставай креды, ха-ха.', [[pjump 'on';]]};
	};
	exit = function()
		set_music('bgm/cosmos-travelling.mod');
	end;
};

dice = function()
	local a, b, c, x, y;
	a = rnd(6); b = rnd(6); c = rnd(6); x = a + b + c;
	p ('На первом кубике выпало - ', a, ', на втором - ', b, ', на третьем - ', c, '. Итого ', x, '.^^ Теперь кидает твой противник.');
	a = rnd(6); b = rnd(6); c = rnd(6); y = a + b + c;
	p ('На первом кубике выпало - ', a, ', на втором - ', b, ', на третьем - ', c, '. Итого ', y, '.^^');
	if x == y then p 'Ничья. Нет победителя.';
	elseif x > y then p 'Ты победил, вот твои кредиты. Дай мне отыграться? Еще раунд?'; global_var_credits = global_var_credits + 50;
	elseif x < y then p 'Ха-ха, ты проиграл, давай твои креды сюда, неудачник.'; global_var_credits = global_var_credits - 50;
	end;
end;

amua_dlg = dlg {
	nam = 'Переговоры с колонистом';
	pic = 'gfx/Amua.png';
	enter = 'На экране появилось изображение, покрытое помехами, передающая аппаратура на той стороне явно была не в лучшем состоянии. Человек, одетый в простую домотканую одежду, произнес на архаичном диалекте:^- Приветствую вас, земляне. Наконец-то кто-то нашел нас и может нам помочь.';
	phr = {
		{tag = 'on', false, 'Кто вы?', '- Записи в основном утеряны, но я могу точно сказать, что мы колонисты и высадились на этом чуде генетики около трехсот лет назад. Раса создавшая это, обладала исключительными познаниями в науке. Тем более странно, что мы не нашли на кольце никого. Только это растение, оно поглощает свет звезды, водород и космическую пыль и вырабатывает кислород, запасает воду в огромных капсулах, тут есть плоды и растительные нити пригодные для тканей. Капитан, помогите нам и мы не останемся в долгу!'};
		{tag = 'on', false, 'В чем помочь?', '- Пожиратель! Раз в семьдесят пять лет со стороны красной звезды прилетает огромный корабль и поглощает часть кольца. В первый раз он захватил наш корабль и убил большую часть колонистов. С тех пор он всегда выбирает самую населенную часть и нападает. Мы пытались защищаться, но у нас нет технологий и металлов. Мой отец в прошлый раз стартовал к Пожирателю в последней шлюпке набитой самодельным порохом. Его уничтожила лазерная защита Пожирателя.', [[pon 'red';]]};
		{tag = 'red', false, 'Вы пытались установить контакт?', '- Пытались, но без успеха. Этот Пожиратель похоже просто автомат с определенной программой. Вы сделате доброе дело уничтожив его.'};
		{tag = 'red', false, 'У красной звезды есть планеты?', '- Возможно когда-то и были, но теперь уже точно нет. Мы исследуем её при помощи телескопов уже почти три сотни лет. При расширении красный гигант вымел из системы даже астероиды. Там нет ничего.'};
		{tag = 'red', false, 'Хорошо, мы разберемся в ситуации.', '- Поспешите, Пожирателю осталось менее суток, чтобы начать свою программу уничтожения.', [[objs(Amua):add('red_star'); poff 'on'; poff 'red'; back();]]};

	};
};

amua2_dlg = dlg {
	nam = 'У красного гиганта';
	pic = 'gfx/amua2.png';
	enter = 'Планета в атмосфере красного гиганта, нужно приблизиться, - неожиданно включился пси дроид.^- Капитан, это опасно, хотя в короне звезды всего около трех тысяч по кельвину, но защитные поля могут не выдержать.';
	phr = {
		{tag = 'on', 'Летим обратно и расстреляем этот механизм.', '- Так точно капитан.', [[back();]]};
		{tag = 'on', 'Исследуем до конца. Защитное поле на максимум! Погружаемся.', 'Недалеко от поверхности звезды и правда нашлась выжженная планетка землеподобного типа, сенсоры нарисовали впадины океанов и русла рек на поверхности.^- Капитан, жизнь! Внутри планеты океаны, города и транспортные линии. А вот и космопорт для этого Пожирателя, он доставляет ресурсы этой расе. Невероятно.', [[pon 'cont';]]};
		{tag = 'cont', false, 'Установить контакт!', '- Есть ответ. Сенсоры воспринимают радиоволны, но универсальный переводчик не может расшифровать их, - произнес Морзе.'};
		{tag = 'cont', false, 'Дроид, прочти их мысли!', '- Принято. Расшифровка мыслеобразов. Они построили лесное кольцо и пожирателя. Когда их звезда начала расширяться, они спрятались внутрь.', [[pon 'why'; poff 'on'; poff 'cont';]]};
		{tag = 'why', false, 'Но почему они не покинули планету? У них ведь была техническая возможность.', '- Снаружи холодно и пусто. Они не оставят дом.'};
		{tag = 'why', false, 'Передай им то, что делает их пожиратель.', '- Раса в таком отчаянии, - проскрипел пси дроид, - механизм не передает изображений, только привозит еду, воздух и воду. Он запрограммирован удалять пораженные участки. Они в трауре из-за погибших людей. Они предлагают самоубийство своего вида, если это искупит разрушение.', [[pon 'not';]]};
		{tag = 'not', false, 'Это лишнее, спроси, можно ли перепрограммировать пожирателя?', '- Капитан, принимаю кодированную передачу. Записываю, - доложил Морзе.', [[pon 'end';]]};
		{tag = 'end', false, 'Кажется, мы сделали тут все, что можно, возвращаемся.', '- Ложимся на обратный курс, - ответил Морзе.^^"Созвездие" вернулось к кольцу и передало записанные команды на пожирателя. Тот развернулся от населенной людьми части кольца и полетел к необитаемым зарослям.', [[objs(Amua):del('red_star'); objs(Amua):del('big_ship'); back();]]};

	};
};

amua3_dlg = dlg {
	nam = 'У красного гиганта';
	pic = 'gfx/amua2.png';
	enter = 'Я ощущаю жизнь внутри, в атмосфере звезды, - неожиданно произнес слизень-пассажир, помахав своими глазами на стебельках.^- Капитан, это опасно, хотя в короне звезды всего около трех тысяч по кельвину, но защитные поля могут не выдержать.';
	phr = {
		{tag = 'on', 'Летим обратно и расстреляем этот механизм.', '- Так точно капитан.', [[back();]]};
		{tag = 'on', 'Исследуем до конца. Защитное поле на максимум! Погружаемся.', 'Недалеко от поверхности звезды и правда нашлась выжженная планетка землеподобного типа, сенсоры нарисовали впадины океанов и русла рек на поверхности.^- Капитан, жизнь! Внутри планеты океаны, города и транспортные линии. А вот и космопорт для этого Пожирателя, он доставляет ресурсы этой расе. Невероятно.', [[pon 'cont';]]};
		{tag = 'cont', false, 'Установить контакт!', '- Есть ответ. Сенсоры воспринимают радиоволны, но универсальный переводчик не может расшифровать их, - произнес Морзе.'};
		{tag = 'cont', false, 'Слизень, вы понимаете эти сигналы?', '- Сложно, старые диалекты галактики. Так не говорят уже миллионы лет. Но вам повезло, я знаю этот язык. Они живут в планете, которая некогда породила их. Когда их звезда начала расширяться, они спрятались внутрь.', [[pon 'why'; poff 'on'; poff 'cont';]]};
		{tag = 'why', false, 'Но почему они не покинули планету? У них ведь была техническая возможность.', '- Снаружи холодно и пусто. Они не оставят дом.'};
		{tag = 'why', false, 'Передай им то, что делает их пожиратель.', '- Раса в таком отчаянии, - сказал слизень, - механизм не передает изображений, только привозит еду, воздух и воду. Он запрограммирован удалять пораженные участки. Они в трауре из-за погибших людей. Они предлагают самоубийство своего вида, если это искупит разрушение.', [[pon 'not';]]};
		{tag = 'not', false, 'Это лишнее, спроси, можно ли перепрограммировать пожирателя?', '- Капитан, принимаю кодированную передачу. Записываю, - доложил Морзе.', [[pon 'end';]]};
		{tag = 'end', false, 'Кажется, мы сделали тут все, что можно, возвращаемся.', '- Ложимся на обратный курс, - ответил Морзе.^^"Созвездие" вернулось к кольцу и передало записанные команды на пожирателя. Тот развернулся от населенной людьми части кольца и полетел к необитаемым зарослям.', [[objs(Amua):del('red_star'); objs(Amua):del('big_ship'); back();]]};

	};
};

amua4_dlg = dlg {
	nam = 'У красного гиганта';
	pic = 'gfx/amua2.png';
	enter = 'Капитан, слабый сигнал на М-коммуникаторе. Интересные данные.';
	phr = {
		{tag = 'on', 'Летим обратно и расстреляем этот механизм.', '- Так точно капитан.', [[back();]]};
		{tag = 'on1', false, 'Исследуем до конца. Защитное поле на максимум! Погружаемся.', 'Недалеко от поверхности звезды и правда нашлась выжженная планетка землеподобного типа, сенсоры нарисовали впадины океанов и русла рек на поверхности.^- Капитан, жизнь! Внутри планеты океаны, города и транспортные линии. А вот и космопорт для этого Пожирателя, он доставляет ресурсы этой расе. Невероятно.', [[pon 'cont';]]};
		{tag = 'cont', false, 'Установить контакт!', '- Есть ответ. Сенсоры воспринимают радиоволны, но универсальный переводчик не может расшифровать их, - произнес Морзе.'};
		{tag = 'cont', false, 'Подключи М-коммуникатор к пульту связи.', '- Готово, получаю данные. Они живут в планете, которая некогда породила их. Когда их звезда начала расширяться, они спрятались внутрь.', [[pon 'why'; poff 'on'; poff 'cont';]]};
		{tag = 'why', false, 'Но почему они не покинули планету? У них ведь была техническая возможность.', '- Расшифровка. Снаружи холодно и пусто. Они не оставят дом.'};
		{tag = 'why', false, 'Передай им то, что делает их пожиратель.', '- Получаю ответ. Они в отчаянии, механизм не передает изображений, только привозит еду, воздух и воду. Он запрограммирован удалять пораженные участки. Они в трауре из-за погибших людей. Они предлагают самоубийство своего вида, если это искупит разрушение.', [[pon 'not';]]};
		{tag = 'not', false, 'Это лишнее, спроси, можно ли перепрограммировать пожирателя?', '- Капитан, принимаю кодированную передачу. Записываю, - доложил Морзе.', [[pon 'end';]]};
		{tag = 'end', false, 'Кажется, мы сделали тут все, что можно, возвращаемся.', '- Ложимся на обратный курс, - ответил Морзе.^^"Созвездие" вернулось к кольцу и передало записанные команды на пожирателя. Тот развернулся от населенной людьми части кольца и полетел к необитаемым зарослям.', [[objs(Amua):del('red_star'); objs(Amua):del('big_ship'); back();]]};

	};
};

slug_dlg = dlg {
	nam = 'Пассажир Слизень';
	pic = 'gfx/slug_dlg.png';
	enter = 'Чем я могу помочь вам, капитан, совета ищете у мудрости?';
	phr = {
		{'Как вас зовут?', 'Слизень покачал глазами на стебельках.^- Это мое имя, но вы в силу физиологического несовершенства не может воспроизвести его. Я не обижаюсь.'};
		{always = true, 'В какую систему вас нужно доставить?', code[[p ('- В систему ', global_var_passenger_target, ', капитан.');]]};
		{always = true, 'Это нужная вам система?', code[[p ('- Нет, это ', from().nam, ', капитан.');]]};
		{always = true, 'Нет, ничего.', '- Идите с миром, капитан.', [[back();]]};
	};
};

slug2_dlg = dlg {
	nam = 'Пассажир Слизень';
	pic = 'gfx/slug_dlg.png';
	enter = 'Чем я могу помочь вам, капитан, совета ищете у мудрости?';
	phr = {
		{tag = 'on', 'Слизень, я получил интересную информацию, касающуюся вас. Вас разыскивают десяток планет и хотят засунуть в самую глубокую дыру, где не светит солнце. К чему бы это?', 'Слизень покачал глазами на стебельках.^- Это просто ксенофобы. Я пытался наладить контакт с отсталыми обитателями нескольких звездных систем и приобщить их к мудрости моей расы. Но был не понят и вынужден был бежать на первом же полуразвалившемся грузовике.', [[pon 'otv';]]};
		{tag = 'otv', false, 'Хорошо, это объясняет угон, а как насчет контрабанды?', '- Предметы культа, не более капитан. Фимиам для медитаций и прочее.'};
		{tag = 'otv', false, 'Или расскажите мне про охоту за головами?', '- Всего-лишь проповедь. Влияние моих речей, несущих просвещение, на некоторые неокрепшие умы было признано этими дикарями пагубным.'};
		{tag = 'otv', false, 'Ну или про побег из тюрьмы?', '- Инстинкт самосохрания. Они уже складывали костер, когда я решился проскользнуть между прутьями решетки и бежать в космопорт.'};
		{tag = 'otv', false, 'Эм, что тут еще, обнажение, храп, уродливость, плохой запах, вот ерунда.', '- Именно, капитан. Обвинения пустые как скорлупа бронта.'};
		{always = true, 'Закончить разговор и оставить Слизня на борту.', '- Вы приняли правильное решение, капитан.', [[pon 'on'; back();]]};
		{always = true, 'Закончить разговор и отдать приказ о выдаче Слизня на Барбантам.', '- Вы приняли неправильное решение, капитан.', code[[lifeoff 'slug'; global_var_credits = global_var_credits + rnd(100); pon 'on';  back();]]};
	};
};

Centauri_dlg = dlg {
	nam = 'Видеосвязь';
	pic = 'gfx/Centauri.png';
	enter = 'Капитан Киркунов нажал одну из клавиш на подлокотнике капитанского кресла. На экране рубки появилось изображение адмирала Владимира.^- "Созвездие", ответьте! О, есть контакт! Не знаю, что вы тут делаете, но вы очень вовремя. На нас тут напал неизвестный противник. Пригодится любая помощь.';
	phr = {
		{'Уже известный, это Доваки. Я везу информацию о них и предупреждение, правда второе уже не пригодилось.', '- Отлично, заливайте мне все, что у вас есть. Аналитики уже готовы. Знание тактики врага уменьшит потери...^- Проклятье, а это что? - Из воронки гиперперехода в вспышках молний вынырнуло нечто гигантское и ярко сияющее. Звезда? Да, это звезда, окруженная паутиной ферм и направляющих. Слабое мерцание силового поля окружало конструкцию.^- Что это за хрень?! - Воскликнул, повторяясь, адмирал Владимир, - они звезду в качестве движка запрягли? "Созвездие", вы должны придержать эту штуку, пока мы добиваем ранее прибывшего противника. Нельзя дать им объединиться, иначе у нас не будет и шанса.', [[pon 'star';]]};
		{tag = 'star', false, 'Вы понимаете что сражаться против этой "Звезды Смерти" - задание весьма самоубийственное?', '- Это война, солдат. Я не могу ослабить основные силы, иначе мы повторим ошибку противника и разделим силы. Так что вперед, я вам потом какую-нибудь медаль выпишу или даже орден.'};
		{tag = 'star', false, 'Приказ понят. Подмога какая будет?', '- Продержитесь час, и весь флот прилетит на подмогу. Я отправил к вам шлюпку с ремонтным дроидом, вы выглядите потрепанными. Удачи вам, капитан.', code[[Centauri.pic = 'gfx/Boss.png'; global_var_repair_droid_life = 100; objs(Centauri):add('death_star_post'); objs(Centauri):add('death_star_gen'); objs(Centauri):add('death_star_laser'); objs(Centauri):del('general_vladimir'); back();]]};
	};
};

gizka_dlg = dlg {
	nam = 'Разговор с Морзе';
	pic = 'gfx/gizka.png';
	enter = '- Да, капитан?';
	phr = {
		{always = true, 'Морзе, что это за грызуны у нас тут прыгают?', '- Это гизки, капитан. В целом безвредны, только проводку иногда грызут.'};
		{always = true, 'Как избавиться от этих существ?', '- Можно попробовать отравить. Проблема в том, что их метаболизм позволяет переваривать практически любое органическое вещество.'};
		{always = true, 'Больше нет вопросов, старпом.', '- Так точно, капитан.', [[back();]]};
	};
};

spika_dlg = dlg {
	nam = 'Торговый пост Спики';
	pic = 'gfx/spika_dlg.png';
	enter = function()
		p 'Спика-пика. Железо, металл, спика! - Произнес спикианец в очках, обозначающих принадлежность к инженерной касте, которая еще не полностью ушла в дикость.';
		poff ('nanoprocessors', 'chip', 'laser_crystals', 'palladium', 'unobtainium', 'adamantium', 'kryptonite', 'red_mercury');
		if have 'nanoprocessors' then pon 'nanoprocessors'; end;
		if have 'chip' then pon 'chip'; end;
		if have 'laser_crystals' then pon 'laser_crystals'; end;
		if have 'palladium' then pon 'palladium'; end;
		if have 'unobtainium' then pon 'unobtainium'; end;
		if have 'adamantium' then pon 'adamantium'; end;
		if have 'kryptonite' then pon 'kryptonite'; end;
		if have 'red_mercury' then pon 'red_mercury'; end;
	end;
	phr = {
		{always = true, 'Ремонт корабля на 5% - 40K', code[[if global_var_life == 100 then p '- Спика-пика, корабль целый совсем.'; elseif global_var_credits < 40 then p '- Спика-пика. Нету кредов, нету работы.'; elseif global_var_life > 95 then global_var_life = 100; global_var_credits = global_var_credits - 40; p '- Готово.'; elseif global_var_life < 96 then global_var_life = global_var_life + 5; global_var_credits = global_var_credits - 40; p '- Готово.'; end;]]};
		{always = true, 'Охладить реактор - 40K.', code[[if global_var_reactor > 8 then p '- Спика-пика, реактор хороший.' elseif global_var_credits < 40 then p '- Спика-пика. Нету кредов, нету работы.'; else global_var_reactor = global_var_reactor + 1; global_var_credits = global_var_credits - 40;  p '- Готово.'; end;]]};
		{tag = 'laser_crystals', false, 'Продать кристаллы - 120K', code[[if have 'laser_crystals' then p '- Готово.'; global_var_credits = global_var_credits + 120; inv():del(laser_crystals); else p '- Спика-пика, нет кристаллов.'; end;]]};
		{tag = 'nanoprocessors', false, 'Продать нанопроцессоры - 90K.', code[[if have 'nanoprocessors' then p '- Готово.'; global_var_credits = global_var_credits + 70; inv():del(nanoprocessors); else p '- Спика-пика, нет нанопроцессор, нет кредитов.'; end;]]};
		{tag = 'chip', false, 'Продать микросхему - 45K.', '- Готово.', code[[global_var_credits = global_var_credits + 45; inv():del(chip);]]};
		{tag = 'palladium', false, 'Продать палладий - 120K.', '- Готово.', code[[global_var_credits = global_var_credits + 120; inv():del(palladium);]]};
		{tag = 'unobtainium', false, 'Продать анобтаниум - 130K.', '- Готово.', code[[global_var_credits = global_var_credits + 130; inv():del(unobtainium);]]};
		{tag = 'adamantium', false, 'Продать адамантиум - 130K.', '- Готово.', code[[global_var_credits = global_var_credits + 130; inv():del(adamantium);]]};
		{tag = 'kryptonite', false, 'Продать криптонит - 80K.', '- Готово.', code[[global_var_credits = global_var_credits + 80; inv():del(kryptonite);]]};
		{tag = 'red_mercury', false, 'Продать красную ртуть - 120K.', code[[if have 'red_mercury' then p '- Готово.'; global_var_credits = global_var_credits + 120; inv():del(red_mercury); else p '- Спика-пика, нет ртути, нет кредитов.'; end;]]};
		{always = true, 'Прервать сеанс связи.', nil, [[objs(from()):del('station'); back();]]};
	};
};

pirate_mercy_dlg = dlg {
	nam = 'Переговоры с пиратами';
	pic = 'gfx/pirate.png';
	enter = 'Внезапно экран связи осветился и на нем появилась уродливая физиономия космического пирата из расы Кредлов. Знакомое выражение лица, впрочем Кредлы все на редкость похожи и одинаково уродливы.^- Капитан, вы сильнее и мы просим пощады. Мы можем сделать вам хорошее коммерческое предложение, если вы нас не добьете.';
	phr = {
		{tag = 'one', 'Продолжайте.', '- У нас есть кое-что, мы можем поделиться.', code[[if not have 'nanoprocessors' then p 'Например качественные нанопроцессоры!'; pon 'nanoprocessors'; elseif not have 'chip' then p 'Например микросхема!'; pon 'chip'; elseif not have 'laser_crystals' then p 'Например лазерные кристаллы!'; pon 'laser_crystals'; else p 'Например кредиты! 50к, нет даже 100к!' pon 'credits'; end;]]};
		{tag = 'nanoprocessors', false, 'Хм, интересное предложение. Хорошо, я не буду тратить торпеды на вас в обмен на нанопроцессоры. Но предупреждаю, не стоит вам больше появляться в этом секторе.', '- Разумеется-разумеется, капитан. Я продам свое корыто и осяду где-нибудь фермером и никогда больше вас не потревожу.', [[take 'nanoprocessors'; pon 'one'; objs(from()):del(pirate_cruiser); objs(from()):del(pirate_cruiser_with_dealer); global_var_count = 3; ways(from()):enable_all(); if visits(from()) > 1 then path('Расчет прыжка', from()):disable(); end; if global_var_reactor < 4 then objs(from()):enable('wait'); end; back();]]};
		{tag = 'chip', false, 'Хм, интересное предложение. Хорошо, я не буду тратить энергию лазеров на вас в обмен на микросхему. Но предупреждаю, не стоит вам больше появляться в этом секторе.', '- Разумеется-разумеется, капитан. Я продам свое корыто и осяду где-нибудь фермером и никогда больше вас не потревожу.', code[[take 'chip'; pon 'one'; objs(from()):del(pirate_cruiser); objs(from()):del(pirate_cruiser_with_dealer); global_var_count = 3; ways(from()):enable_all(); if visits(from()) > 1 then path('Расчет прыжка', from()):disable(); end; if global_var_reactor < 4 then objs(from()):enable('wait'); end; back();]]};
		{tag = 'laser_crystals', false, 'Хм, интересное предложение. Хорошо, я не буду тратить торпеды на вас в обмен на лазерные кристаллы. Но предупреждаю, не стоит вам больше появляться в этом секторе.', '- Разумеется-разумеется, капитан. Я продам свое корыто и осяду где-нибудь фермером и никогда больше вас не потревожу.', code[[take 'laser_crystals'; pon 'one'; objs(from()):del(pirate_cruiser); objs(from()):del(pirate_cruiser_with_dealer); global_var_count = 3; ways(from()):enable_all(); if visits(from()) > 1 then path('Расчет прыжка', from()):disable(); end; if global_var_reactor < 4 then objs(from()):enable('wait'); end; back();]]};
		{tag = 'credits', false, 'Хм, интересное предложение. Хорошо, я не буду тратить торпеды на вас в обмен на 100К кредитов. Но предупреждаю, не стоит вам больше появляться в этом секторе.', '- Разумеется-разумеется, капитан. Я продам свое корыто и осяду где-нибудь фермером и никогда больше вас не потревожу.', code[[global_var_credits = global_var_credits + 100; pon 'one'; objs(from()):del(pirate_cruiser); objs(from()):del(pirate_cruiser_with_dealer); global_var_count = 3; ways(from()):enable_all(); if visits(from()) > 1 then path('Расчет прыжка', from()):disable(); end;	if global_var_reactor < 4 then objs(from()):enable('wait'); end; back();]]};
		{always = true, 'Никаких переговоров, огонь по противнику!', nil, [[pon 'one'; back();]]};
	};
};

pawnshop_dlg = dlg {
	nam = 'Киберстарьевщик';
	pic = 'gfx/pawnshop.png';
	enter = function()
		p 'Капитан зашел в помещение, заваленное всякими устройствами и механизмами явно неисправного вида. Вдруг из угла со скрежетом выполз один из экспонатов и произнес на общегалактическом: "Приветствую вас покупатель. У меня есть самые древние артефакты и следы потерянных цивилизаций. Инфокристаллы с нерасшифрованным содержимым, электроника и охлаждающие реагенты."';
		poff ('chip', 'laser_crystals', 'mental_communicator', 'analyzer');
		pon ('infocrystal', 'coolant');
		if global_var_factory_rnd == 1 then pon 'chip';
		elseif global_var_factory_rnd == 2 then pon 'laser_crystals';
		elseif global_var_factory_rnd == 3 then pon 'mental_communicator';
		elseif global_var_factory_rnd == 4 then pon 'analyzer';
		end;
	end;
	phr = {
		{tag = 'chip', false, 'Приобрести микросхему - 100K', code[[if have 'chip' then p '- У вас уже есть микросхема.'; elseif global_var_credits < 100 then p '- Недостаточно кредитов.'; else p '- Готово.'; global_var_credits = global_var_credits - 100; take 'chip'; end;]]};
		{tag = 'laser_crystals', false, 'Приобрести лазерные кристаллы - 100K', code[[if have 'laser_crystals' then p '- У вас уже есть лазерные кристаллы.'; elseif global_var_credits < 100 then p '- Недостаточно кредитов.'; else p '- Готово.'; global_var_credits = global_var_credits - 100; take 'laser_crystals'; end;]]};
		{tag = 'coolant', 'Приобрести охладитель - 100K', code[[if have 'coolant' then p '- У вас уже есть охладитель.'; elseif global_var_credits < 100 then p '- Недостаточно кредитов.'; else p '- Готово.'; global_var_credits = global_var_credits - 100; take 'coolant'; end;]]};
		{tag = 'mental_communicator', false, 'Приобрести ментальный коммуникатор - 100K', code[[if have 'mental_communicator' then p '- У вас уже есть ментальный коммуникатор.'; elseif global_var_credits < 100 then p '- Недостаточно кредитов.'; else p '- Готово.'; global_var_credits = global_var_credits - 100; take 'mental_communicator'; end;]]};
		{tag = 'analyzer', false, 'Приобрести анализатор вероятностей - 100K', code[[if have 'analyzer' then p '- У вас уже есть такой анализатор.'; elseif global_var_credits < 100 then p '- Недостаточно кредитов.'; else p '- Готово.'; global_var_credits = global_var_credits - 100; take 'analyzer'; end;]]};
		{tag = 'infocrystal', 'Приобрести инфокристалл - 100K.', code[[if have 'infocrystal' then p '- У вас уже есть такой товар.'; elseif global_var_credits < 100 then p '- Недостаточно кредитов.'; else p '- Готово.'; global_var_credits = global_var_credits - 100; take 'infocrystal'; end;]]};
		{always = true, 'Покинуть станцию.', nil, [[objs(from()):del('station'); back();]]};
	};
};
