-- $Name:Созвездие: Полёт в бездну$
-- $Version:1.04$
-- $Name(ru):Созвездие: Полёт в бездну$
instead_version "1.8.0"

require "xact"			-- подключаем модуль xact
require "hideinv"		-- подключаем модуль hideinv
require "para"			-- догадайтесь, что мы подключили в этот раз ;)
require "dash"			-- подключаем dash
require "quotes"		-- подключаем quotes
require "nolife"
require "click"
--require "dbg"

dofile "battle.lua"
dofile "dialogues.lua"
dofile "other.lua"
dofile "bolo.lua"
dofile "logbook.lua"
dofile "asteroids.lua"

game.codepage="UTF-8";

game.act = 'Не получается.';
game.inv = 'Хм, странная штука.';
game.use = 'Не сработает.';

global {
global_var_event = 1;
global_var_torpedo = 10;
global_var_torpedo_rnd = 1;
global_var_laser_rnd = 1;
global_var_life = 100;
global_var_credits = 200;
global_var_pirate_rnd = 1;
global_var_factory_rnd = 1;
global_var_station_rnd = 1;
global_var_customs_rnd = 0;
global_var_dovak_fighters = 3;
global_var_next_system = '';
global_var_death_star_post_life = 100;
global_var_death_star_gen_life = 100;
global_var_death_star_laser_life = 100;
global_var_repair_droid_life = 55;
global_var_random_jump = 1;
global_var_reactor = 8;
global_var_count = 3;
global_var_lasers_mk = 1;
global_var_drink = 0;
global_var_passenger_target = '';
global_var_system_count = 0;
global_var_trophy = 1;
global_var_cap_dlg = 0;
global_var_one = 0;
global_var_enemy_life = 0;
global_var_bolo_life = 100;
global_var_random_planet = 0;
global_var_bolo_count = 15;
global_var_bolo_rnd = 0;
array = {};
field = 'blank:750x300;';
bolo_x = 350;
bolo_y = 150;
global_var_music = 1;
};

---Начало---------------------------------------------------------------------------------------------------------------

main = room {
	forcedsc = true;
	nam = "На мостике";
	pic = 'gfx/enter.png';
	enter = function()
		set_music('bgm/cosmos-travelling.mod');
		take 'logbook';
		take 'arms';
		take 'lasers';
		take 'photon_torpedo';
		take 'droids';
		take 'repair_droid';
		take 'hold';
		take 'coolant';
--		take 'kryptonite';
--		take 'hyperradio';
	end;
	dsc = 'Эта игра про доблестного капитана Киркунова и его боевой космический корабль флота земной федерации {constellation|"Созвездие"}. Сейчас корабль под обстрелом и его догоняют истребители расы Доваков. Старший помощник {morze|Морзе} докладывает о входящем видеосигнале.^На капитанском кресле справа находятся клавиши управления кораблем, сверху {temp|индикатор температуры реактора}, далее схематичное {body|изображение корпуса}, ниже состояние {shield|щитов}. Тут же клавиша открывающая {log|бортжурнал}. Отдельным блоком клавиши запуска {torp|фотонных торпед} и активации {las|лазерных батарей}. Также отображается наличие {cargo|особенных грузов} в трюме.';
	obj = {xact('constellation', '"Созвездие" - это один из самых современных кораблей флота Федерации, проекта 94, бортовой номер К-117. Построен в 2224 при сотрудничестве "КосмоВАЗа", "Южмаша" и "Челябинского Тракторного".'); xact('morze', 'Морзе - это старший помощник и правая рука капитана Киркунова.'); xact('temp', 'Не допускайте перегрева реактора, это может привести к катастрофе.'); xact('body', 'Отображаемые повреждения напрямую зависят от состояния щитов.'); xact('shield', 'Не доводите это значение до нуля. Используйте ремонтного дроида или услуги на станциях.'); xact('log', 'Сообщения в бортжурнале иногда могут быть полезными.'); xact('torp', 'Наиболее эффективное оружие, но может быстро кончиться.'); xact('las', 'Лазерные батареи имеют свой индикатор заряда, наибольшие повреждения врагу достаются при выстреле на максимальном заряде.'); xact('cargo', 'Грузы могут быть полезными и не очень.');
--уровни сложности
	xact('easy', code[[if not have 'boarding_droid' then putto('superlaser', inv(), 4); putto('boarding_droid', inv(), 8); global_var_repair_droid_life = 100; global_var_torpedo = 15; global_var_credits = 300; end; return true;]]);
	xact('normal', code[[inv():del(boarding_droid); inv():del(superlaser); global_var_repair_droid_life = 55; global_var_torpedo = 10; return true;]]);
	xact('hard', code[[inv():del(boarding_droid); inv():del(superlaser); global_var_repair_droid_life = 0; global_var_torpedo = 5; global_var_credits = 100; return true;]]);};
	way = {vroom('Ответить на видеовызов', 'adm_dlg')};
};

post = room {
	forcedsc = true;
	nam = "На мостике";
	pic = 'gfx/Space_station.png';
	dsc = '{constellation|"Созвездие"} уже набрало нужную скорость для прыжка. Иногда корабль потряхивало и моргало освещение. Истребители Доваков не отстают, но силовые щиты пока держатся. {morze|Морзе} сидит за пультом связи.';
	obj = {xact('constellation', '"Созвездие" - это один из самых современных кораблей флота Федерации, проекта 94, бортовой номер К-117. Построен в 2224 при сотрудничестве "КосмоВАЗа", "Южмаша" и "Челябинского Тракторного".'); xact('morze', 'Морзе - это старший помощник и правая рука капитана Киркунова.');};
	way = {'Beta_Chertana', 'Denebola'};
};

---Первый прыжок---------------------------------------------------------------------------------------------------------------

Beta_Chertana = room {
	forcedsc = true;
	nam = 'Бета Чертана';
	pic = 'gfx/Beta_Chertana.png';
	enter = function(s)
		global_var_next_system = 'Furud';
		global_var_system_count = 1;
		random_event();
	end;
	dsc = 'Белый субгигант одиноко висит в пространстве. Только астероиды его товарищи.';
	way = {'U128396', vroom('Расчет прыжка', 'Beta_Chertana')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

Denebola = room {
	forcedsc = true;
	nam = "Денебола";
	pic = 'gfx/Denebola.png';
	enter = function(s)
		global_var_next_system = 'Furud';
		global_var_system_count = 1;
		random_event();
	end;
	dsc = 'Красный гигант жарит практически в своей короне троицу невезучих планет. ';
	way = {'U128396', vroom('Расчет прыжка', 'Denebola')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

---Второй прыжок---------------------------------------------------------------------------------------------------------------

U128396 = room {
	forcedsc = true;
	nam = "U128396";
	pic = 'gfx/U128396.png';
	enter = function(s)
		global_var_next_system = 'Limbo';
		global_var_system_count = 2;
		random_event();
	end;
	dsc = 'Красный карлик тускло освещает пару промороженных планет. ';
	way = {'Furud', vroom('Расчет прыжка', 'U128396')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

---Третий прыжок---------------------------------------------------------------------------------------------------------------

Furud = room {
	forcedsc = true;
	nam = "Фуруд";
	pic = 'gfx/Furud.png';
	enter = function(s)
		global_var_next_system = 'Hors_Nebula';
		global_var_system_count = 3;
		random_event();
	end;
	dsc = 'Тусклого коричневого карлика окружает целая вереница планет разного калибра, да еще и пара астероидных поясов. ';
	way = {'Limbo', vroom('Расчет прыжка', 'Furud')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

-----Четвертый прыжок---------------------------------------------------------------------------------

Limbo = room {
	forcedsc = true;
	nam = "Лимбо";
	pic = 'gfx/Limbo.png';
	enter = function(s)
		global_var_next_system = 'Omicron_Persey';
		global_var_system_count = 4;
		random_event();
	end;
	dsc = 'Одинокая серая планета освещена красным светом своей звезды.';
	way = {'Hors_Nebula', vroom('Расчет прыжка', 'Limbo')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

----Пятый прыжок-------------------------------------------------------------------------------------

Hors_Nebula = room {
	forcedsc = true;
	nam = "Туманность Лошадиная Голова";
	pic = 'gfx/Hors_Nebula.png';
	enter = function(s)
		global_var_next_system = 'Delta_Triangle';
		global_var_system_count = 5;
		random_event();
	end;
	dsc = 'Красноватое свечение пронизывает туманность.';
	way = {'Omicron_Persey', vroom('Расчет прыжка', 'Hors_Nebula')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

----Шестой прыжок-------------------------------------------------------------------------------------

Omicron_Persey = room {
	forcedsc = true;
	nam = 'Омикрон Персея';
	pic = 'gfx/Omicron_Persey.png';
	enter = function(s)
		global_var_next_system = 'Zeta7';
		global_var_system_count = 6;
		random_event();
	end;
	dsc = 'Малоисследованная система, на звездной карте "Созвездия" отмечена как необитаемая.';
	way = {'Delta_Triangle', vroom('Расчет прыжка', 'Omicron_Persey')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

----Седьмой прыжок-------------------------------------------------------------------------------------

Delta_Triangle = room {
	forcedsc = true;
	nam = "Дельта Треугольника";
	pic = 'gfx/Delta_Triangle.png';
	enter = function(s)
		global_var_next_system = 'Kerbol';
		global_var_system_count = 7;
		random_event();
	end;
	dsc = 'Двойная звезда окружена кольцами пыли. Планеты пока не сформировались.';
	way = {'Zeta7', vroom('Расчет прыжка', 'Delta_Triangle')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------8 прыжок------------------------------------------------------------------------------

Zeta7 = room {
	forcedsc = true;
	nam = "Zeta-7";
	pic = 'gfx/Zeta7.png';
	enter = function(s)
		global_var_next_system = 'Salamander';
		global_var_system_count = 8;
		random_event();
	end;
	dsc = 'Близкая туманность освещает фиолетовым систему Zeta-7.';
	way = {'Kerbol', vroom('Расчет прыжка', 'Zeta7')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------9 прыжок------------------------------------------------------------------------------

Kerbol = room {
	forcedsc = true;
	nam = "Кербол";
	pic = 'gfx/Kerbol.png';
	enter = function(s)
		global_var_next_system = 'Belule';
		global_var_system_count = 9;
		random_event();
	end;
	dsc = 'В системе Кербол крутится десяток планет с кучей спутников.';
	way = {'Salamander', vroom('Расчет прыжка', 'Kerbol')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------10 прыжок------------------------------------------------------------------------------

Salamander = room {
	forcedsc = true;
	nam = "Саламандра";
	pic = 'gfx/Salamander.png';
	enter = function(s)
		global_var_next_system = 'Meta';
		global_var_system_count = 10;
		random_event();
		if live 'slug' then
			p 'Слизень произнес: - Благодарю вас, капитан. Позвольте в качестве благодарности оставить вам немного кредитов.^После чего выполз в шлюз и улетел на своей шлюпке к ближайшей станции.';
			global_var_credits = global_var_credits + rnd(100);
			lifeoff('slug');
		end;
	end;
	dsc = 'Система состоит из двух планет без атмосферы. Органической жизни на поверхности нет.';
	way = {'Belule', vroom('Расчет прыжка', 'Salamander')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

-----11 прыжок----------------------------------------------------------

Belule = room {
	forcedsc = true;
	nam = "Белюль";
	pic = 'gfx/Belule.png';
	enter = function(s)
		global_var_next_system = 'X624855';
		global_var_system_count = 11;
		random_event();
	end;
	dsc = 'Множество планет крутится вокруг звезды системы Белюль.';
	way = {'Meta', vroom('Расчет прыжка', 'Belule')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

-----12 прыжок----------------------------------------------------------

Meta = room {
	forcedsc = true;
	nam = "Мета";
	pic = 'gfx/Meta.png';
	enter = function(s)
		global_var_next_system = 'Coruscant';
		global_var_system_count = 12;
		random_event();
	end;
	dsc = 'В этой системе есть только безымянная крохотная пустынная планета, на которой царит вечный день. Два солнца, белый гигант и красный карлик, сменяют друг друга на небосклоне, окрашивая пески и небо в разные цвета.';
	way = {'X624855', vroom('Расчет прыжка', 'Meta')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

-----13 прыжок----------------------------------------------------------

X624855 = room {
	forcedsc = true;
	nam = "X624855";
	pic = 'gfx/X624855.png';
	enter = function(s)
		global_var_next_system = 'Aksam';
		global_var_system_count = 13;
		random_event();
	end;
	dsc = 'Вокруг безымянной звезды вращается одинокая планета Барбантам окуженная сотнями спутников.';
	way = {'Coruscant', vroom('Расчет прыжка', 'X624855')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------14 прыжок------------------------------------------------------

Coruscant = room {
	forcedsc = true;
	nam = "Корусант";
	pic = 'gfx/Coruscant.png';
	enter = function(s)
		global_var_next_system = 'Emerson';
		global_var_system_count = 14;
		random_event();
	end;
	dsc = 'Полуразрушенные небоскребы на единственной планете в системе видны даже из космоса.';
	way = {'Aksam', vroom('Расчет прыжка', 'Coruscant')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------15 прыжок------------------------------------------------------

Aksam = room {
	forcedsc = true;
	nam = "Аксам";
	pic = 'gfx/Aksam.png';
	enter = function(s)
		global_var_next_system = 'Amua';
		global_var_system_count = 15;
		random_event();
	end;
	dsc = 'Тусклый синий свет далекого светила едва освещает однообразные пейзажи покинутых планет.';
	way = {'Emerson', vroom('Расчет прыжка', 'Aksam')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------16 прыжок------------------------------------------------------

Emerson = room {
	forcedsc = true;
	nam = "Эмерсон";
	pic = 'gfx/Emerson.png';
	enter = function(s)
		global_var_next_system = 'Red_sun';
		global_var_system_count = 16;
		random_event();
	end;
	dsc = 'В системе Эмерсона обнаружилось множество искусственных спутников и оживленное внутрисистемное движение.';
	way = {'Amua', vroom('Расчет прыжка', 'Emerson')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------17 прыжок------------------------------------------------------

Amua = room {
	forcedsc = true;
	nam = "Амуа";
	pic = 'gfx/Amua.png';
	enter = function(s)
		global_var_next_system = 'Gamma_Eridan';
		global_var_system_count = 17;
		random_event();
	end;
	dsc = 'Двойная звезда Амуа состоит из белого карлика G8 и красного гиганта.';
	way = {'Red_sun', vroom('Расчет прыжка', 'Amua')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------18 прыжок------------------------------------------------------

Red_sun = room {
	forcedsc = true;
	nam = "Рыжая Звезда";
	pic = 'gfx/Red_sun.png';
	enter = function(s)
		global_var_next_system = 'Dzeta_Aphrodite';
		global_var_system_count = 18;
		random_event();
	end;
	dsc = 'Звезда интересного оранжевого спекта освещает несколько планет.';
	way = {'Gamma_Eridan', vroom('Расчет прыжка', 'Red_sun')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------19 прыжок------------------------------------------------------

Gamma_Eridan = room {
	forcedsc = true;
	nam = "Гамма Эридана";
	pic = 'gfx/Gamma_Eridan.png';
	enter = function(s)
		global_var_next_system = 'X624856';
		global_var_system_count = 19;
		random_event();
	end;
	dsc = 'Несколько планет в этой системе пригодня для жизни.';
	way = {'Dzeta_Aphrodite', vroom('Расчет прыжка', 'Gamma_Eridan')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------20 прыжок------------------------------------------------------

Dzeta_Aphrodite = room {
	forcedsc = true;
	nam = "Дзета Афродиты";
	pic = 'gfx/Dzeta_Aphrodite.png';
	enter = function(s)
		global_var_next_system = 'Sanctuarium';
		global_var_system_count = 20;
		random_event();
	end;
	dsc = 'Дзета Афродиты маленькая темная система, очень старый коричневый карлик уже почти не дает света в видимом спектре. Даже звезды и особенно крупная близлежащая туманность светят лучше.';
	way = {'X624856', vroom('Расчет прыжка', 'Dzeta_Aphrodite')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------21 прыжок------------------------------------------------------

X624856 = room {
	forcedsc = true;
	nam = "X624856";
	pic = 'gfx/X624856.png';
	enter = function(s)
		global_var_next_system = 'Hiadum2';
		global_var_system_count = 21;
		random_event();
	end;
	dsc = 'Красный карлик освещает несколько газовых гигантов.';
	way = {'Sanctuarium', vroom('Расчет прыжка', 'X624856')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------22 прыжок------------------------------------------------------

Sanctuarium = room {
	forcedsc = true;
	nam = "Санктуарий";
	pic = 'gfx/Sanctuarium.png';
	enter = function(s)
		global_var_next_system = 'Barnard';
		global_var_system_count = 22;
		random_event();
	end;
	dsc = 'Вокруг газового гиганта вращается пара пригодных для жизни спутников.';
	way = {'Hiadum2', vroom('Расчет прыжка', 'Sanctuarium')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------23 прыжок------------------------------------------------------

Hiadum2 = room {
	forcedsc = true;
	nam = 'Хиадум II';
	pic = 'gfx/Hiadum2.png';
	enter = function(s)
		global_var_next_system = 'Tsig';
		global_var_system_count = 23;
		random_event();
	end;
	dsc = 'Желтый карлик освещает несколько крупных планет, окруженных кольцами льда и обломков спутников.';
	way = {'Barnard', vroom('Расчет прыжка', 'Hiadum2')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------24 прыжок------------------------------------------------------

Barnard = room {
	forcedsc = true;
	nam = "Звезда Барнарда";
	pic = 'gfx/Barnard.png';
	enter = function(s)
		global_var_next_system = 'Sheratan';
		global_var_system_count = 24;
		random_event();
	end;
	dsc = 'Красного карлика сопровождает только одна покрытая джунглями и мелкими морями планета.';
	way = {'Tsig', vroom('Расчет прыжка', 'Barnard')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------25 прыжок------------------------------------------------------

Tsig = room {
	forcedsc = true;
	nam = "Тсиг";
	pic = 'gfx/Tsig.png';
	enter = function(s)
		global_var_next_system = 'Hidra_head';
		global_var_system_count = 25;
		random_event();
	end;
	dsc = 'Тсиг - маленькая необитаемая система. Единственная планета имеет метановую атмосферу и не представляет коммерческого интереса. ';
	way = {'Sheratan', vroom('Расчет прыжка', 'Tsig')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------26 прыжок------------------------------------------------------

Sheratan = room {
	forcedsc = true;
	nam = "Шератан";
	pic = 'gfx/Sheratan.png';
	enter = function(s)
		global_var_next_system = 'Polaris';
		global_var_system_count = 26;
		random_event();
	end;
	dsc = 'Многочисленные обломки биокораблей кружатся на орбите планеты Шер, иногда с огненным следом рассекая атмосферу и находя последнее пристанище на поверхности.';
	way = {'Hidra_head', vroom('Расчет прыжка', 'Sheratan')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------27 прыжок------------------------------------------------------

Hidra_head = room {
	forcedsc = true;
	nam = "Голова Гидры";
	pic = 'gfx/Hidra_head.png';
	enter = function(s)
		global_var_next_system = 'Fornazis';
		global_var_system_count = 27;
		random_event();
	end;
	dsc = 'В системе Головы Гидры есть пригодная для жизни планета.';
	way = {'Polaris', vroom('Расчет прыжка', 'Hidra_head')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------28 прыжок------------------------------------------------------

Polaris = room {
	forcedsc = true;
	nam = "Полярис";
	pic = 'gfx/Polaris.png';
	enter = function(s)
		global_var_next_system = 'X624844';
		global_var_system_count = 28;
		random_event();
	end;
	dsc = 'Звезда Поларис светит на синию планету.';
	way = {'Fornazis', vroom('Расчет прыжка', 'Polaris')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------29 прыжок------------------------------------------------------

Fornazis = room {
	forcedsc = true;
	nam = "Форнацис";
	pic = 'gfx/Fornazis.png';
	enter = function(s)
		global_var_next_system = 'Fomalhaut';
		global_var_system_count = 29;
		random_event();
	end;
	dsc = 'Вокруг звезды Форнацис обращается крупная планета с красивейшими ледяными кольцами.';
	way = {'X624844', vroom('Расчет прыжка', 'Fornazis')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------30 прыжок------------------------------------------------------

X624844 = room {
	forcedsc = true;
	nam = "X624844";
	pic = 'gfx/X624844.png';
	enter = function(s)
		global_var_next_system = 'Eracis';
		global_var_system_count = 30;
		random_event();
	end;
	dsc = 'Залетная черная дыра поглощает систему номер X624844.';
	way = {'Fomalhaut', vroom('Расчет прыжка', 'X624844')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------31 прыжок------------------------------------------------------

Fomalhaut = room {
	forcedsc = true;
	nam = "Фомальгаут";
	pic = 'gfx/Fomalhaut.png';
	enter = function(s)
		global_var_next_system = 'Maya';
		global_var_system_count = 31;
		random_event();
	end;
	dsc = '"Созвездие" вышло из прыжка почти в атмосфере крупного газового гиганта Фомальгаут-4.';
	way = {'Eracis', vroom('Расчет прыжка', 'Fomalhaut')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------32 прыжок------------------------------------------------------

Eracis = room {
	forcedsc = true;
	nam = "Эракис";
	pic = 'gfx/Eracis.png';
	enter = function(s)
		global_var_next_system = 'Mintaca';
		global_var_system_count = 32;
		random_event();
	end;
	dsc = 'Небольшое солнце Эракис освещает одноименную песчаную планету.';
	way = {'Maya', vroom('Расчет прыжка', 'Eracis')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------33 прыжок------------------------------------------------------

Maya = room {
	forcedsc = true;
	nam = "Майя";
	pic = 'gfx/Maya.png';
	enter = function(s)
		global_var_next_system = 'Navi';
		global_var_system_count = 33;
		random_event();
	end;
	dsc = 'Вокруг белой звезды вращается только несколько ледяных планет.';
	way = {'Mintaca', vroom('Расчет прыжка', 'Maya')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------34 прыжок------------------------------------------------------

Mintaca = room {
	forcedsc = true;
	nam = "Минтака";
	pic = 'gfx/Mintaca.png';
	enter = function(s)
		global_var_next_system = 'Pleyona';
		global_var_system_count = 34;
		random_event();
	end;
	dsc = 'Мощное пылевое облако окружает звезду системы Минтака.';
	way = {'Navi', vroom('Расчет прыжка', 'Mintaca')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------35 прыжок------------------------------------------------------

Navi = room {
	forcedsc = true;
	nam = "Нави";
	pic = 'gfx/Navi.png';
	enter = function(s)
		global_var_next_system = 'Rasalhag';
		global_var_system_count = 35;
		random_event();
	end;
	dsc = 'Вокруг газового гиганта вращается пара пригодных для жизни спутников.';
	way = {'Pleyona', vroom('Расчет прыжка', 'Navi')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------36 прыжок------------------------------------------------------

Pleyona = room {
	forcedsc = true;
	nam = "Плейона";
	pic = 'gfx/Pleyona.png';
	enter = function(s)
		global_var_next_system = 'Electra';
		global_var_system_count = 36;
		random_event();
		if live 'slug' then 
			p 'Слизень произнес: - Благодарю вас, капитан. Позвольте в качестве благодарности оставить вам немного кредитов.^После чего выполз в шлюз и улетел на своей шлюпке к ближайшей станции.';
			global_var_credits = global_var_credits + rnd(100);
			lifeoff('slug');
		end;
	end;
	dsc = 'В системе Плейона множество исскуственных спутников.';
	way = {'Rasalhag', vroom('Расчет прыжка', 'Pleyona')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------37 прыжок------------------------------------------------------

Rasalhag = room {
	forcedsc = true;
	nam = "Расальхаг";
	pic = 'gfx/Rasalhag.png';
	enter = function(s)
		global_var_next_system = 'Spika';
		global_var_system_count = 37;
		random_event();
	end;
	dsc = 'Стабильная желтая звезда в главной последовательности освещает пять планет системы Расалхаг.';
	way = {'Electra', vroom('Расчет прыжка', 'Rasalhag')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------38 прыжок------------------------------------------------------

Electra = room {
	forcedsc = true;
	nam = "Электра";
	pic = 'gfx/Electra.png';
	enter = function(s)
		global_var_next_system = 'Terebellum';
		global_var_system_count = 38;
		random_event();
	end;
	dsc = 'В системе Электры есть редкий феномен, двойная планета. Один из компонентов типичный газовый гигант, а второй относится к классу суперземель.';
	way = {'Spika', vroom('Расчет прыжка', 'Electra')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------39 прыжок------------------------------------------------------

Spika = room {
	forcedsc = true;
	nam = "Спика";
	pic = 'gfx/Spika.png';
	enter = function(s)
		global_var_next_system = 'Manubrium2';
		global_var_system_count = 39;
		random_event();
	end;
	dsc = 'Недостроенная сфера дайсона окружает солнце Спики.';
	way = {'Terebellum', vroom('Расчет прыжка', 'Spika')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------40 прыжок------------------------------------------------------

Terebellum = room {
	forcedsc = true;
	nam = "Теребеллум";
	pic = 'gfx/Terebellum.png';
	enter = function(s)
		global_var_next_system = 'KeQuan';
		global_var_system_count = 40;
		random_event();
	end;
	dsc = 'Система не обитаема. Ценных ресурсов нет.';
	way = {'Manubrium2', vroom('Расчет прыжка', 'Terebellum')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------41 прыжок------------------------------------------------------

Manubrium2 = room {
	forcedsc = true;
	nam = "Манубриум 2";
	pic = 'gfx/Manubrium2.png';
	enter = function(s)
		global_var_next_system = 'Diadema';
		global_var_system_count = 41;
		random_event();
	end;
	dsc = 'Двойная звезда Манубриума 2 освещает полный комплект разнообразных планет. Одна из них входит в зону жизни, но необитаема.';
	way = {'KeQuan', vroom('Расчет прыжка', 'Manubrium2')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------42 прыжок------------------------------------------------------

KeQuan = room {
	forcedsc = true;
	nam = "Ке Кван";
	pic = 'gfx/KeQuan.png';
	enter = function(s)
		global_var_next_system = 'Megrez';
		global_var_system_count = 42;
		random_event();
	end;
	dsc = 'Цивилизованные места. Движение космических судов в системе Ке Кван разрешено только под управлением автоматики по специальным трассам.';
	way = {'Diadema', vroom('Расчет прыжка', 'KeQuan')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------43 прыжок------------------------------------------------------

Diadema = room {
	forcedsc = true;
	nam = "Диадема";
	pic = 'gfx/Diadema.png';
	enter = function(s)
		global_var_next_system = 'Regul';
		global_var_system_count = 43;
		random_event();
	end;
	dsc = 'Система Диадема обязана названием синей планете с ярко блистающем в свете местного светила кольцом.';
	way = {'Megrez', vroom('Расчет прыжка', 'Diadema')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------44 прыжок------------------------------------------------------

Megrez = room {
	forcedsc = true;
	nam = "Мегрец";
	pic = 'gfx/Megrez.png';
	enter = function(s)
		global_var_next_system = 'South_Asel';
		global_var_system_count = 44;
		random_event();
	end;
	dsc = 'Несколько планет со следами промышленных разработок тускло освещает небольшое солнце.';
	way = {'Regul', vroom('Расчет прыжка', 'Megrez')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {'asteroid'};
};

------45 прыжок------------------------------------------------------

Regul = room {
	forcedsc = true;
	nam = "Регул";
	pic = 'gfx/Regul.png';
	enter = function(s)
		global_var_next_system = 'Pollucs';
		global_var_system_count = 45;
		random_event();
	end;
	dsc = 'Вокруг газового гиганта с множеством колец вращается крупный пригодный для жизни спутник.';
	way = {'South_Asel', vroom('Расчет прыжка', 'Regul')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------46 прыжок------------------------------------------------------

South_Asel = room {
	forcedsc = true;
	nam = "Южный Асель";
	pic = 'gfx/South_Asel.png';
	enter = function(s)
		global_var_next_system = 'Eden_Prime';
		global_var_system_count = 46;
		random_event();
	end;
	dsc = 'Звезда Южного Аселя освещает множество планет разного калибра';
	way = {'Pollucs', vroom('Расчет прыжка', 'South_Asel')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------47 прыжок------------------------------------------------------

Pollucs = room {
	forcedsc = true;
	nam = "Поллукс";
	pic = 'gfx/Pollucs.png';
	enter = function(s)
		global_var_next_system = 'AmonRa';
		global_var_system_count = 47;
		random_event();
	end;
	dsc = 'После древней катастрофы в системе Поллукса летает множество астероидов различного размера.';
	way = {'Eden_Prime', vroom('Расчет прыжка', 'Pollucs')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------48 прыжок------------------------------------------------------

Eden_Prime = room {
	forcedsc = true;
	nam = "Эден Прайм";
	pic = 'gfx/Eden_Prime.png';
	enter = function(s)
		global_var_next_system = 'Centauri';
		global_var_system_count = 48;
		random_event();
		if live 'gizka' then 
			p '- Морзе, а куда пропали эти гизки?^- При последней стыковке с торговой станцией, они все убежали с корабля через шлюз. У меня нехорошее предчувствие капитан.';
			lifeoff('gizka');
		end;
	end;
	dsc = 'В системе Эден Прайм имеется пригодная для колонизации планета с хорошим климатом.';
	way = {'AmonRa', vroom('Расчет прыжка', 'Eden_Prime')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------49 прыжок------------------------------------------------------

AmonRa = room {
	forcedsc = true;
	nam = "Амон-Ра";
	pic = 'gfx/AmonRa.png';
	enter = function(s)
		global_var_next_system = 'Centauri'; --Все верно, иначе прыжок наудачу приведет опять в АмонРа.
		global_var_system_count = 49;
		random_event();
		path('Расчет прыжка'):disable();
		if live 'slug' then 
			p 'Слизень произнес: - Благодарю вас, капитан. Позвольте в качестве благодарности оставить вам немного кредитов.^После чего выполз в шлюз и улетел на своей шлюпке к ближайшей станции.';
			global_var_credits = global_var_credits + rnd(100);
			lifeoff('slug');
		end;
		if live 'gizka' then 
			p '- Морзе, а куда пропали эти гизки?^- При последней стыковке с торговой станцией, они все убежали с корабля через шлюз. У меня нехорошее предчувствие капитан.';
			lifeoff('gizka');
		end;
	end;
	dsc = 'Вокруг системы двойной звезды обращается несколько планет.';
	way = {'Centauri', vroom('Расчет прыжка', 'Centauri')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			global_var_one = 0;
		end;
	end;
	obj = {};
};

------Финиш------------------------------------------------------

Centauri = room {
	forcedsc = true;
	nam = "Альфа Центавра";
	pic = 'gfx/Centauri.png';
	enter = function(s)
		p '"Созвездие" прибыло во время ожесточенного сражения. Похоже, что предупреждение запоздало и Седьмой флот уже вовсю отражал атаку Доваков.';
		set_music('bgm/imperialattack.mod');
		global_var_system_count = 50;
		global_var_reactor = global_var_reactor - 1;
		if global_var_reactor == 0 then walk(end3);
		elseif global_var_reactor < 3 and rnd(7) == 1 then walk(end3);
		else objs():add('general_vladimir');
		end;
	end;
};

----------Плохие концовки-------------------------------------------------------

end1 = room {
	nam = 'Конец';
	pic = 'gfx/end.png';
	enter = function()
		set_music('bgm/burntime-ende.mod');
		lifeoff('slug');
		lifeoff('gizka');
		objs():disable_all();
	end;
	hideinv = true;
	dsc = 'Хоть "Созвездие" и отличный корабль, но отнюдь не неуязвимый. Это конец вашего приключения.';
};

end2 = room {
	nam = 'Конец';
	pic = 'gfx/end2.png';
	enter = function()
		set_music('bgm/burntime-ende.mod');
		lifeoff('slug');
		lifeoff('gizka');
		objs():disable_all();
	end;
	hideinv = true;
	dsc = 'Прыжок оказался неудачным. "Созвездие" выкинуло вблизи черной дыры и гравитация разорвала корабль на части. Это конец вашего приключения.';
};

end3 = room {
	nam = 'Конец';
	pic = 'gfx/end3.png';
	enter = function()
		set_music('bgm/burntime-ende.mod');
		lifeoff('slug');
		lifeoff('gizka');
		objs():disable_all();
	end;
	hideinv = true;
	dsc = 'Реактор не выдержал нагрузки и началась неконтролируемая реакция. "Созвездие" разорвало взрывом на мелкие части. Это конец вашего приключения.';
};

Secret_system_2 = room {
	forcedsc = true;
	nam = 'Неизвестная система';
	pic = 'gfx/Secret_system_2.png';
	enter = function(s)
		path('Расчет прыжка'):disable();
		ways():add(global_var_next_system);
		global_var_event = rnd(6);
		if global_var_event == 1 then
			walk(end2);
		elseif global_var_event == 2 then
			objs():add('sphere');
		elseif global_var_event == 3 then
			set_music('bgm/lexx1_02_Prisoner_transport.ogg');
			here().pic = 'gfx/lexx.png';
			objs():add('lexx');
		elseif global_var_event == 4 then
			set_music('bgm/suburbancommando-spaceship2.mod');
			global_var_enemy_life = 120;
			here().pic = 'gfx/Secret_system_2_1.png';
			p '- Обнаружена боевая станция куборгов. - Доложил Морзе.^- Старпом, а почему их так называют? Забавное название.^- Ответ очевиден, капитан. Их боевая станция представляет собой куб, как вы можете видеть. Соответсвенно его обитатели - куборги. Все логично. И я рекомендую незаметно улететь отсюда. У нас важная миссия, а сражение с куборгами может повредить корабль.^- Отставить панику, старпом. Хотя разумное зерно в ваших словах имеется.';
			objs():add('cube');
		else
			p ('Курс "Созвездия" пересек небольшой астероидный поток. Сканеры обнаружили среди камней небольшой подбитый метеоритом грузовоз. Ценные материалы перегружены в трюмы. Всю систему просканировали, но более ничего ценного тут нет.');
			global_var_credits = global_var_credits + rnd(50);
		end;
		if global_var_reactor < 3 then objs():add('wait'); end;
	end;
	dsc = 'Безымянная белая звезда класса А освещает только несколько газовых гигантов.';
	way = {vroom('Расчет прыжка', 'Secret_system_2')};
	exit = function(s, t)
		if t ~= s and not isDialog(t) then 
			set_music('bgm/cosmos-travelling.mod');
		end;
	end;
	obj = {};
};

----------Титры-------------------------------------------------------

titles = room {
	forcedsc = true;
	nam ='Титры';
	pic = 'gfx/titles.png';
	hideinv = true;
	enter = function()
		lifeoff('slug');
		lifeoff('gizka');
	end;
	dsc = [[Автор: Irremann^
Графика: из википедии, девиантарта и некоторые картинки из гугла, если нашли что-то нарушающие чьи-то авторские права, то напишите мне.^
Музыка: http://modarchive.org^^
В создании игры участие принимали: @DarknessKeeper, @AFAIK, @ap-Codkelden, @Radjah, @FGNTFG, @hagane, @h-s, @zweipluse, j-maks, Peter.^
Особая благодарность Tenebricus с fallout.ru за нахождение миллиона ошибок в текстах.^
Cпасибо excelenter за звук выстрела из суперлазера.^
Также я благодарю всех с juick.com и из конференции instead@conference.jabber.ru за моральную поддержку.^^
Контакты: arsche@jabber.ru, yatopor@gmail.com^^^
Не прощаюсь, будет еще. Если не в виде игры, то в виде рассказов например.^
Читайте http://juick.com/?tag=созвездие^^ Удачи.]];
};
