---Запрет сохранений-------------------------------------------------------------------------------------

function game.enable_save() return false; end;

---Статус корабля----------------------------------------------------------------------------------

status = stat {
	nam = function()
		local i;
		p (img('pad:0 3 0 15,gfx/icon_radiation_24.png'));
		for i = 1, global_var_reactor do
			if global_var_reactor > 8 then global_var_reactor = 8;
			elseif global_var_reactor > 5 then p (img 'box:12x12,green,128');
			elseif global_var_reactor > 3 then p (img 'box:12x12,yellow,128');
			else p (img 'box:12x12,red,128');
			end;
		end;
		p '^^';
		if global_var_life > 60 then p (img('pad:0 35,gfx/constell-full.png'));
		elseif global_var_life > 30 then p (img('pad:0 35,gfx/constell-half-damaged.png'));
		else p (img('pad:0 35,gfx/constell-damaged.png'));
		end;
		p ('^^'..img('pad:0 3 0 15,gfx/icon_shield_24.png'), global_var_life, '%'..img('pad:0 3 0 15,gfx/icon_money_24.png'), global_var_credits, 'K^');
	end;
};

function init()
    inv():add('status');
end;

arms = stat {
	nam = 'Вооружение';
	disp = img 'gfx/arms.png'..txtu ' Вооружение';
};

droids = stat {
	nam = 'Дроиды';
	disp = img 'gfx/droids.png'..txtu ' Дроиды';
};

hold = stat {
	nam = 'Трюм';
	disp = img 'gfx/hold.png'..txtu ' Трюм';
};

---Объекты--------------------------------------------------------------------------

hyperradio = obj {
	nam = 'Гипер-радио';
	inv = function(s)
		global_var_music = global_var_music + 1;
		if global_var_music == 8 then global_var_music = 1; end;
		tracks = {'cosmos-travelling',
			'tracks_of_harmony',
			'lift_off',
			'suburbancommando-spaceship2',
			'galactica_sln',
			'galacticlove',
			'imperialattack',
		};
		set_music('bgm/'..tracks[global_var_music]..'.mod');
		p 'Капитан провел рукой по сенсорной панели гипер-радио, выбирая частоту. О кажется что-то неплохое.';
--		p(tracks[global_var_music]);
	end;
};

asteroid = obj {
	nam = 'Астероид';
	act = 'Крупный астероид неправильной формы.';
	dsc = 'В космосе рядом с "Созвездием" обнаружен {астероид}.';
};

factory = obj {
	nam = 'Торговая станция';
	act = function()
		objs():del('factory');
		if rnd(2) == 1 then walk(factory_dlg);
		else walk(pawnshop_dlg); end;
	end;
	dsc = 'Пристыковаться к {торговой станции}?';
};

passenger = obj {
	nam = 'Пассажир';
	act = function()
			p 'Спасибо, что взяли на борт, капитан. Я не доставлю вам много хлопот.';
			objs():del('passenger');
			put(slug);
			lifeon(slug);
	end;
	dsc = function()
		p ('На экране появилось изображение глаз на стебельках: Капитан, сэр, прошу вас о помощи другому разумному. Мой корабль поврежден, и я застрял на этой перевалочной станции. {Возьмите меня на борт} и доставьте в систему ', global_var_passenger_target, '. И моя благодарность не будет знать границ.');
	end;
};

ancient_ship = obj {
	nam = 'Древний корабль';
	act = function()
			p 'Капитан переключил дроида на внешнюю связь. Древний корабль вздрогнул, пробуждаясь ото сна и гостеприимно открыл один из люков.';
			if global_var_factory_rnd == 1 then
				p 'Но не успело "Созвездие" пристыковаться, как древний корабль взорвался. Получены серьезные повреждения.';
				global_var_life = global_var_life - rnd(30);
				if global_var_life <= 0 then walk(end1); global_var_life = 0; end;
			elseif global_var_factory_rnd == 2 and global_var_lasers_mk < 3 then 
				p 'Инженеры смогли демонтировать системы лазерного наведения и установить их на "Созвездие".';
				global_var_lasers_mk = global_var_lasers_mk + 1;
			else
				p 'В бортовом компьтере корабля оказался заложен курс к неизвестной системе, по какой-то причине отсутствующей на звездных картах "Созвездия".';
				ways():add('Secret_system_2');
			end;
			objs():del('ancient_ship');
	end;
	dsc = function()
		if have 'psy_droid' then
			p 'Внезапно включился дроид псионик: Капитан, передайте {код доступа} этому кораблю.';
		else p 'Капитан отметил в бортжурнале координаты, но далее возиться с артефактом времени нет.';
		end;
	end;
};

customs = obj {
	nam = 'Таможенный контроль';
	act = function()
		walk(customs_dlg);
	end;
	dsc = 'Морзе воскликнул: Капитан, нас окружили {боевые корабли} и вызывают нас на сеанс видеосвязи.';
};

beacon = obj {
	nam = 'Маяк';
	act = function()
		p '*Треск* - Добро пожаловать, странники. Вас приветствует самый лучший и недорогой порт в этой части галактики. Ваш корабль того и гляди рассыпется? Вам нужен кислород, хлор или другие дыхательные газы? Вам хочется весело провести время и промочить глотку? Тогда вас рады будут видеть механики, заправочные станции и бары нашего веселого порта *шипение*.';
		objs():add('trap');
		objs():del('beacon');
	end;
	dsc = 'Сенсоры принимают {сообщение} с одной из лун газового гиганта. Похоже на автоматический маяк.^';
};

trap = obj {
	nam = 'Ловушка';
	act = function()
		objs():del('trap');
		Omicron_Persey.pic = 'gfx/trap.png';
		if rnd(2) == 1 then
			p 'Второй спутник газового гиганта, оказался весьма крупным и обладающим атмосферой. "Созвездие" следуя сигналу снижалось, как вдруг из облаков вылетели истребители. Это ловушка!';
			global_var_enemy_life = 150;
			objs():add('dovak_fighters');
			objs():disable('wait');
			ways():disable_all();
		else
			p 'На орбите крупной луны газового гиганта оказался автоматический спутник, транслирующий запись этого сообщения. Но порта или каких-либо поселений тут нет. Странно.';
		end;
	end;
	dsc = 'Сообщение повторяется по кругу. {Примем предложение} или летим дальше?';
};

help = obj {
	nam = 'Сигнал';
	act = function()
		if seen(big_ship, Amua) then
			walk(amua_dlg);
			pon 'on';
		else
			p 'Вы победили его и спасли нас! Примите нашу благодарность. У нас нет технологий, но есть кое-какие ценности, которые мы выращиваем.';
			take 'laser_crystals';
			objs():del('help');
			global_var_one = 1;
		end;
	end;
	dsc = 'Наши сенсоры принимают {сообщение о помощи} из лесного кольца. На устаревшей полосе частот космофлота.';
};

big_ship = obj {
	nam = 'Сборщик урожая';
	act = 'Огромный, черный и покрытый оспинами и окалинами. Очень древний. Сканеры не обнаруживают на борту биологических форм жизни.';
	dsc = 'И какой-то {огромный корабль} направляется в сторону этого орбитального кольца.';
};

red_star = obj {
	nam = 'Красный гигант';
	act = function()
		if have 'psy_droid' then walk(amua2_dlg);
		elseif live 'slug' then walk(amua3_dlg);
		elseif have 'mental_communicator' then walk(amua4_dlg);
		else p 'Около красного гиганта и правда нет ни намека на обитаемую планету, астероид или даже станцию. Только космическая пыль. Возвращаемся.';
		objs():del('red_star');
		end;
	end;
	dsc = 'В паре парсеков мрачно светит {красный гигант}.';
};

general_vladimir = obj {
	nam = 'Видеовызов';
	act = function()
		walk(Centauri_dlg);
	end;
	dsc = 'На экране замигала {иконка видеовызова}.';
};

random_jump = obj {
	nam = 'Случайный прыжок';
	act = function()
		global_var_random_jump = rnd(5);
		if global_var_random_jump == 1 then walk('Secret_system_dlg');
		elseif global_var_random_jump == 2 then walk('end2');
		else
			ways():enable_all();
			global_var_count = 3;
			p 'Под огнем противника "Созвездие" исчезло в воронке гиперперехода. Через некоторое время корабль появился в новой системе.';
			walk(global_var_next_system);
		end;
	end;
	dsc = 'Корабль сильно поврежден. Этот противник слишком силен для нас. Навигатор еще не обсчитал прыжок, но гипердвигатели уже готовы и мы можем попробовать {прыгнуть на удачу}, без рассчетов.';
};

wait = obj {
	nam = 'Реактор перегрелся';
	act = function()
		objs():disable('wait');
		global_var_reactor = global_var_reactor + 2;
		walk(here());
	end;
	dsc = 'Температура реактора приблизилась к критической отметке. Механики просят несколько часов для охлаждения. Прыжок сейчас может вывести реактор из строя. {Будем ждать?}';
};

sphere = obj {
	nam = 'Сфера';
	act = function()
		walk(sphere_dlg);
		objs(from()):del('sphere');
	end;
	dsc = 'Обнаружена крупная {космическая станция}. Сферической формы.';
};

lexx = obj {
	nam = 'Лекс';
	act = function()
		walk(lexx_dlg);
		objs(from()):del('lexx');
	end;
	dsc = 'Обнаружен крупный {космический объект}. Похож на гигантское насекомое, длина около десяти километров.';
};

eden_beacon = obj {
	nam = 'Маяк Эдена';
	act = function()
		p '- Не обращай внимания старпом. Это старые руины, я как-то дотронулся до одной, а оно как током ударит. Статика наверное. Потом еще кошмары всякие снились.';
		objs():del('eden_beacon');
		global_var_one = 1;
	end;
	dsc = 'Обнаружен {источник сигнала} на поверхности планеты.';
};

slug = obj {
	nam = 'Слизень';
	lf = {
		[1] = '{Слизень} хаотически перемещается по палубе, оставляя скользский след.',
		[2] = '{Слизень} внимательно наблюдает за главным экраном.',
		[3] = '{Слизень} погружен в размышления.',
	};
	act = function()
		walk(slug_dlg);
	end;
	life = function(s)
		if player_moved() then
			move(s, here(), where(s));
		end;
	end;
	dsc = function(s)
		local r = rnd(3);
		r = rnd(#s.lf);
		p(s.lf[r]);
	end;
};

---Трофеи---------------------------------------------------------------------------------------------------------------

laser_crystals = obj {
	nam = 'Кристаллы';
	use = function(s, w)
		if w == lasers then
			if global_var_lasers_mk == 3 then
				p 'У нас и так уже установлена самая лучшая техника.';
			elseif rnd(2) == 1 and global_var_lasers_mk < 3 then
				p 'Установка прошла успешно. Новые кристаллы увеличили точность лазеров.';
				global_var_lasers_mk = global_var_lasers_mk + 1;
				inv():del(laser_crystals);
			elseif rnd(2) == 1 and global_var_lasers_mk > 1 then
				p 'Новые кристаллы оказались с необнаружимым заранее дефектом. Также при их монтаже и снятии с лазеров были повреждены ранее установленные кристаллы.';
				global_var_lasers_mk = global_var_lasers_mk - 1;
				inv():del(laser_crystals);
			else p 'Хм, кажется, эти кристаллы не подходят к нашим системам лазеров.';
			end;
		else p 'Сюда эти кристаллы точно не устанавливаются.';
		end;
	end;
	inv = 'Специальные кристаллы, используемые для фокусировки лазерного луча. Выглядят неплохо.';
};

coolant = obj {
	nam = 'Хладагент';
	inv = function(s, w)
		if global_var_reactor == 8 then
			p 'Температура нашего реактора в пределах нормы. Нет необходимости в дополнительном охлаждении.';
		elseif rnd(3) > 1 then
			p 'Заливка прошла успешно. Новый хладагент более эффективно охлаждает реактор. Температура падает.';
			global_var_reactor = global_var_reactor + rnd(3);
			if global_var_reactor > 8 then global_var_reactor = 8; end;
			inv():del(coolant);
		else
			p 'Хладагент оказался чем-то разбавлен. После заливки температура только выросла.';
			global_var_reactor = global_var_reactor - rnd(3);
			if global_var_reactor < 4 then objs():enable('wait');
			elseif global_var_reactor < 1 then walk(end3); end;
			inv():del(coolant);
		end;
	end;
};

gizka = obj {
	nam = 'Гизка';
	lf = {
		[1] = '{Гизка} выглядывает из-за консоли главного пульта.',
		[2] = '{Гизка} быстро проскакала через всю рубку.',
		[3] = '{Гизка} сидит у входного шлюза и чешется.',
--		[4] = 'Лицехват появился из шлюза и начал тихо подползать к капитанскому креслу. Киркунов уже положил руку на бластер, как из под пульта метнулась {гизка} и в момент сжевала лицехвата.^- Хм, и правда все едят. - Заметил капитан, наблюдая за каплями кислоты, падающими из пасти гизки и шипящими на палубе.',
		[4] = 'Двое {Гизок} стали громко шипеть и скрипеть друг на друга. Морзе поднялся и подкравшись смог схватить одну из них. Пинком выкинув её в шлюз, он сел обратно. Стало потише.',
	};
	act = function()
		walk(gizka_dlg);
	end;
	life = function(s)
		if player_moved() then
			move(s, here(), where(s));
		end;
	end;
	dsc = function(s)
		local r = rnd(4);
		r = rnd(#s.lf);
		p(s.lf[r]);
	end;
};

nanoprocessors = obj {
	nam = 'Нанопроцессоры';
	use = function(s, w)
		if w == repair_droid then
			if rnd(2) == 1 and global_var_repair_droid_life < 40 then
				p 'Установка прошла успешно. Новые нанопроцессоры увеличили ресурс ремонтного дроида.';
				global_var_repair_droid_life = global_var_repair_droid_life + rnd(50);
				inv():del(nanoprocessors);
			elseif global_var_repair_droid_life > 50 then
				p 'В процессе установки младший механик уронил гиперключ прямо на раскрытые схемы ремонтного дроида. Что-то задымило и затрещало.';
				global_var_repair_droid_life = global_var_repair_droid_life - rnd(50);
				inv():del(nanoprocessors);
			else p 'Хм, кажется, эти нанопроцессоры под другой сокет.';
			end;
		else p 'Сюда эти нанопроцессоры точно не устанавливаются.';
		end;
	end;
	inv = 'Нанопроцессоры ракскслианского производства, используемые в дроидотехнике.';
};

chip = obj {
	nam = 'Микросхема';
	use = 'Такие микросхемы уже давно не используются.';
	inv = 'Микросхема типа БИС138КД80 земного производства с ручками для переноски.';
};

palladium = obj {
	nam = 'Палладий';
	use = 'Сюда бесполезно тыкать слитком палладия.';
	inv = 'Контейнер наполнен палладием. Ценный металл, широко используемый в космических сплавах.';
};

repair_droid = obj {
	nam = 'Ремонтный дроид';
	inv = function() if here() ~= repair_droid_dlg then walk(repair_droid_dlg); end; end;
};

unobtainium = obj {
	nam = 'Анобтаниум';
	use = 'Сюда бесполезно тыкать слитком анобтаниума.';
	inv = 'Унобтаний или анобтаниум (лат. unobtainium) - крайне редкий, дорогой и физически невозможный материал, необходимый практически в любой области промышленности.';
};

adamantium = obj {
	nam = 'Адамантиум';
	use = 'Сюда бесполезно тыкать кристаллом адамантиума.';
	inv = 'Адамантиум - сверхпрочный металл высокой ценности. В природе встречается в виде кристаллов весом до нескольких килограмм.';
};

kryptonite = obj {
	nam = 'Криптонит';
	use = 'Сюда бесполезно тыкать кристаллом криптонита.';
	inv = 'Криптонит - кристаллическое радиоактивное вещество, возникшее в результате разрушения планеты Криптон. Имеет высокую ценность.';
};

red_mercury = obj {
	nam = 'Красная ртуть';
	use = 'Осторожнее, это радиоактивный материал.';
	inv = 'Красная ртуть, она же RM-20/20, она же многофункциональный катализатор или Compound-20/20 - жидкое вещество, одна из последних военных разработок Терры. Наиболее коммерчески успешный товар военного экспорта. Это вещество обладает, помимо всего прочего, большой плотностью (20 г/см³), температурой замерзания в −150 °C, токсичностью на уровне KCN и радиоактивностью. Используется в детонаторах кварковых бомб, гаусс-пушках и в сверхмощных военных лазерах.';
};

mental_communicator = obj {
	nam = 'М-коммуникатор';
	use = 'Для применения прибора сначала нужно начать диалог с кем-то.';
	inv = function()
		if here() == repair_droid_dlg or here() == comp_dlg or here() == factory_dlg or here() == sphere_dlg then p 'Детект: искусственный интеллект.^Ошибка: не найден словарь мыслеформ для искусственных интеллектов.';
		elseif here() == adm_dlg then p 'Детект: адмирал Краснов, землянин.^Ощущение: беспокойство, надежда.';
		elseif here() == cap_dlg then p 'Детект: нераспознано, землянин.^Внимание: пространственно-временные аномалии. Сигнал неустойчив.^Ощущение: нераспознано.';
		elseif here() == customs_dlg then p 'Детект: таможенник Кса-кеп, саламандриец.^Четкая мысль: запрошу больше чем надо в два раза, лопухи заплатят, они же не знают суммы таможенного сбора.';
		elseif here() == Emerson_dlg then p 'Детект: командующий Тарасов, землянин.^Ощущение: сильное беспокойство, неуверенность, паника';
		elseif here() == dealer_dlg then p 'Детект: нераспознано, кластерианец.^Ощущение: желание отблагодарить.';
		elseif here() == Secret_system_dlg or here() == amua2_dlg or here() == amua3_dlg then p 'Детект: невозможен.^Отключение.';
		elseif here() == amua4_dlg then
			if punseen 'on1' then pon 'on1'; p 'Детект: роевый разум.^Локализация: в короне красного гиганта.^Ощущение: нераспознано.';
			else p 'Коммуникатор подключен к пульту связи.'; end;
		elseif here() == tavern_dlg then p 'Прибор остался на корабле.';
		elseif here() == amua_dlg then p 'Детект: хранитель Карасев, землянин.^Ощущение: беспокойство.';
		elseif here() == spika_dlg then p 'Детект: инженер Трикс, спикианец.^Ощущение: желание торговаться.';
		elseif here() == slug_dlg or here() == slug2_dlg then p 'Детект: нераспознано, слизень.^Ощущение: благодарность.';
		elseif here() == Centauri_dlg then p 'Детект: генерал Владимир, землянин.^Ощущение: уверенность в победе.';
		elseif here() == gizka_dlg then p 'Детект: старший помощник Морзе, землянин.^Ощущение: меланхоличность.^Детект: неразумное, гизка.^Ощущение: голод.';
		else p 'Спецы из технического отдела осмотрели прибор и вынесли заключение. Ментальный коммуникатор cчитывает основные мысли и ощущения собеседника, анализируя мозговую активность и пси-поле. Неясно как прибор это делает при общении через коммуникатор, но тем не менее результаты тестов показывают 99% эффективность.';
		end;
	end;
};

transmitter = obj {
	nam = 'Передатчик';
	use = function(s, w)
		if w == dovak_scout or w == dovak_fighters then
			if global_var_factory_rnd == 1 then
				p 'Морзе включил передатчик, присоединенный к пульту связи. Кажется сработало. Доваки передали пожелания доброго пути и удаляются.';
				objs():del('dovak_scout');
				objs():del('dovak_fighters');
				global_var_count = 3;
				ways():enable_all();
				if global_var_reactor < 4 then objs():enable('wait'); end;
			else p 'Морзе включил передатчик, присоединенный к пульту связи. Но обман не удался, в ответ полетели ракеты.';
			end;
		else p 'Не сработало.';
		end;
	end;
	inv = 'Передатчик типа свой-чужой, кажется это технологии Доваков.';
};

analyzer = obj {
	nam = 'Анализатор';
	inv = function()
		p 'Небольшое устройство с единственной кнопкой и монохромным экраном. Корпус металлический и выглядит прочным. Снизу табличка "Вероятностный анализатор, опытный образец.", интересно. Капитан нажал кнопку. На экране появилось: ';
		local i = rnd(20);
		if here() == Amua or here() == Omicron_Persey or here() == Limbo or here() == Eden_Prime or here() == Spika then p 'Проверь бортжурнал.';
		elseif live 'slug' and here() == X624855 then p 'Он хороший.';
		elseif here() == Salamander then p 'Время платить.';
		elseif i == 1 then p 'Бесспорно.';
		elseif i == 2 then p 'Предрешено.';
		elseif i == 3 then p 'Никаких сомнений.';
		elseif i == 4 then p 'Определённо да.';
		elseif i == 5 then p 'Можешь быть уверен в этом.';
		elseif i == 6 then p 'Мне кажется - "да".';
		elseif i == 7 then p 'Вероятнее всего.';
		elseif i == 8 then p 'Хорошие перспективы.';
		elseif i == 9 then p 'Знаки говорят - "да".';
		elseif i == 10 then p 'Да.';
		elseif i == 11 then p 'Пока не ясно, попробуй снова.';
		elseif i == 12 then p 'Спроси позже.';
		elseif i == 13 then p 'Лучше не рассказывать.';
		elseif i == 14 then p 'Сейчас нельзя предсказать.';
		elseif i == 15 then p 'Сконцентрируйся и спроси опять.';
		elseif i == 16 then p 'Даже не думай.';
		elseif i == 17 then p 'Мой ответ - "нет".';
		elseif i == 18 then p 'По моим данным - "нет".';
		elseif i == 19 then p 'Перспективы не очень хорошие.';
		elseif i == 20 then p 'Весьма сомнительно.';
		end;
	end;
};

infocrystal = obj {
	nam = 'Инфокристалл';
	inv = function(s)
		local i = rnd(6), o,u;
		o,u = inv():srch('droids');
		if i == 1 then
			p 'Расшифровка кристаллозаписи дала координаты неизвестной системы.';
			ways():add('Secret_system_2');
		elseif i == 2 then
			p 'На инфокристалле оказался "Сборник лучшего пиратского видео 2000-2020гг". Отдали космодесантникам на третью палубу.';
		elseif i == 3 then
			p 'На инфокристалле оказался вирус "Чернобыль-2200". Пока техотдел ловил червя, реактор медленно перегревался.';
			global_var_reactor = global_var_reactor - rnd(5);
			if global_var_reactor < 3 then global_var_reactor = 3; end;
		elseif i == 4 and not have 'infotunnel' then
			p 'На инфокристалле оказалась хакерская утилита "Инфотуннель".';
			putto('infotunnel', inv(), u);
		elseif i == 5 then
			p 'На кристалле оказалась схема сборки высокотехнологичного суперлазера. Для сборки необходим дроид, ремонтный вполне сгодится, а так же такие материалы, как микросхема, лазерные кристаллы, адамантиум и красная ртуть. Полезная информация.';
		elseif i == 6 then
			p 'На кристалле оказался номер счета в Галактическом Банке какого-то пирата. К сожалению средств там оказалось немного.';
			global_var_credits = global_var_credits + rnd(20);
		else p 'Данные оказались слишком сильно повреждены.';
		end;
		remove(s, me());
	end;
};

-----Станция-------------------------------------------------------------

station = obj {
	nam = 'Станция';
	act = function()
		global_var_station_rnd = rnd(15);
		local o,u;
		o,u = inv():srch('hold');
		if global_var_station_rnd == 1 then
			p 'Это заброшенная перевалочная станция астероидных рудокопов. Внутри оказалось немного ценных материалов.';
			global_var_credits = global_var_credits + rnd(50);
		elseif global_var_station_rnd == 2 then
			p 'Это ловушка. Едва "Созвездие" приблизилось, как станция взорвалась. Впрочем щиты выдержали и повреждения оказались незначительными.';
			global_var_life = global_var_life - rnd(10);
			if global_var_life <= 0 then walk(end1); global_var_life = 0; end;
		elseif global_var_station_rnd == 3 then
			p 'Это оказалась старая военная база Конкордата. Склады были кем-то подчищены, но пара фотонных торпед там все-таки завалялась.';
			global_var_torpedo = global_var_torpedo + rnd(3) + 1;
		elseif global_var_station_rnd == 4 then
			p 'Это оказалась старая военная база Конкордата. Склады оказались пустыми.';
			if not have 'boarding_droid' then p 'Но в шлюзе нашелся исправный абордажный дроид.'; putto('boarding_droid', inv(), u);
			elseif not have 'psy_droid' then p 'Но в шлюзе нашелся исправный дроид псионик неизвестной конструкции.'; putto('psy_droid', inv(), u); end;
		elseif global_var_station_rnd == 5 then
			objs():add('ancient_ship');
			p 'Оказалось, что это не станция, а древний корабль странной формы. Весьма древний, так как вакуумная сварка успела наглухо запаять все люки.';
		elseif global_var_station_rnd == 6 then
			if global_var_cap_dlg == 0 then walk (cap_dlg); global_var_cap_dlg = 1;
			else p '^- Одни помехи, капитан. Контакт не удается установить.'; end;
		elseif global_var_station_rnd == 7 then
			p 'Оказалось, что это один из форпостов Земной Федерации. Но злобные Доваки добрались до него раньше вас. В помещениях станции только пятна крови и сломанное оборудование. Капитан Киркунов приказал уничтожить передатчик и двигаться дальше.';
		elseif global_var_station_rnd == 8 then
			p 'Оказалось, что это один из форпостов Земной Федерации. Персонал уже прослышал о вторжении и просил об эвакуации. Капитан Киркунов погрузил людей в криокамеры и приказал снять все ценное со станции.';
			global_var_torpedo = global_var_torpedo + rnd(3);
			global_var_credits = global_var_credits + rnd(20);
		elseif global_var_station_rnd == 9 then
			p 'Оказалось, что это один из форпостов Земной Федерации. Но станция оказалась пуста. Ни следа от персонала. Только еще не остывшая чашка эрзац-кофе на столе в кафетерии.';
		elseif global_var_station_rnd == 10 then
			walk (comp_dlg);
		elseif global_var_station_rnd == 11 then
			if global_var_life < 100 then
				p 'Оказалось, что это местная станция тех.обслуживания. За пару литров спирта механики подлатали "Созвездие" и даже повесили на мостике освежитель-ёлочку.';
				global_var_life = global_var_life + rnd(30);
				if global_var_life > 100 then global_var_life = 100; end;
			else p 'Оказалось, что это местная станция тех.обслуживания. За пару литров спирта механики подкрасили царапины на "Созвездии" и даже повесили на мостике освежитель-елочку.';
			end;
		elseif global_var_station_rnd == 12 then
			p 'Оказалось, что источник сигнала - спасательная капсула неизвестной конструкции. Внутри оказался погруженный в стазис гуманоид. Отправили его ксенологам на опыты.';
		elseif global_var_station_rnd == 13 then
			p 'Источником сигнала оказалась космическая таверна. {xwalk(tavern_dlg)|Стыкуемся?}';
		elseif global_var_station_rnd == 14 then
			objs():add('factory');
			p 'Это автоматическая торговая станция.';
		elseif global_var_station_rnd == 15 then
			p 'Принимаю входящий сигнал. Переключаю, - доложил Морзе.';
			if not seen 'slug' and global_var_system_count < 48 then
				objs():add('passenger');
				if global_var_system_count < 10 then global_var_passenger_target = Salamander.nam;
				elseif global_var_system_count < 35 then global_var_passenger_target = Pleyona.nam;
				elseif global_var_system_count < 48 then global_var_passenger_target = AmonRa.nam;
				else p '^- Одни помехи, капитан. Контакт не удается установить.';
				end;
			else p '- Одни помехи, капитан. Контакт не удается установить.';
			end;
--		elseif global_var_station_rnd == 16 then
--			p 'Источником сигнала оказалась местная доска объявлений.';
--			here().pic = 'gfx/wanted.png';
		end;
		objs():del('station');
	end;
	dsc = 'Морзе воскликнул: Капитан, я засек {слабый сигнал}. Похоже на космическую станцию. У нас есть немного времени, можно отправиться посмотреть.';
};

---Рандом---------------------------------------------------------------------------------------------------------------

random_event = function()
		global_var_event = rnd(15);
		global_var_factory_rnd = rnd(4);
		global_var_reactor = global_var_reactor - 1;
		objs():add('wait');
		objs():disable('wait');
		global_var_random_planet = rnd(4);
		global_var_bolo_count = rnd(10) + 5;
--ремонтник понемногу ремонтирует корабль
		if global_var_repair_droid_life > 0 and global_var_life < 100 then
			global_var_life = global_var_life + rnd(10);
			if global_var_life > 100 then global_var_life = 100; end;
		end;
--гизки понемногу грызут корабль =)
		if live 'gizka' and global_var_life > 11 then
			global_var_life = global_var_life - rnd(10);
		end;
		if visits() > 0 then
			path('Расчет прыжка'):disable();
			ways():add(global_var_next_system);
			objs():del('trap');
			global_var_reactor = global_var_reactor + 2;
		end;
		if global_var_reactor < 4 then objs():enable('wait'); end;
		if here() == Denebola and visits() == 0 then
			p ('"Созвездие" вышло из гиперпространства слишком близко к Денеболе. Получены серьезные повреждения. Не особо удачное начало полета.');
			global_var_life = global_var_life - rnd(50);
		elseif here() == Omicron_Persey and visits() == 0 then
			objs():add('beacon');
		elseif here() == Salamander and visits() == 0 then
			objs():add('customs');
			ways():disable_all();
			objs():disable('wait');
		elseif global_var_event == 1 then
			if rnd(2) == 1 then
				p ('Корональный выброс с местной звезды накрыл "Созвездие". Щиты поглотили большую часть энергии, но небольшие повреждения все-таки нанесены. Морзе внес поправки в курс и можно лететь дальше.');
			else
				objs():add('a_field');
				objs():add('autopilot');
				ways():disable_all();
				objs():disable('wait');

			end;
			global_var_life = global_var_life - rnd(10);
			if global_var_life <= 0 then walk(end1); end;
		elseif global_var_event == 2 then
			objs():add('dovak_scout');
			global_var_enemy_life = 30;
			ways():disable_all();
			objs():disable('wait');
		elseif global_var_event == 3 then
			objs():add('pirate_base');
			global_var_enemy_life = 80;
			objs():disable('wait');
		elseif global_var_event == 4 then 
			objs():add('dovak_fighters');
			global_var_enemy_life = 150;
			ways():disable_all();
			objs():disable('wait');
		elseif global_var_event == 5 then 
			objs():add('pirate_cruiser_with_dealer');
			global_var_enemy_life = 60;
			ways():disable_all();
			objs():disable('wait');
		elseif global_var_event == 6 then 
			objs():add('pirate_cruiser');
			global_var_enemy_life = 60;
			ways():disable_all();
			objs():disable('wait');
		elseif global_var_event == 7 then 
			objs():add('berserker_with_dealer');
			global_var_enemy_life = 60;
			ways():disable_all();
			objs():disable('wait');
		elseif global_var_event == 8 then 
			objs():add('berserker_with_trade_post');
			global_var_enemy_life = 60;
			ways():disable_all();
			objs():disable('wait');
		elseif global_var_event == 9 and here() ~= Beta_Chertana and here() ~= Hors_Nebula and here() ~= Limbo and here() ~= Omicron_Persey and here() ~= Delta_Triangle and here() ~= X624855 and here() ~= Coruscant and here() ~= Amua and here() ~= X624856 and here() ~= Spika then
			if here() == Denebola then global_var_random_planet = 1; end; --жареная планета
			if here() == U128396 or here() == Salamander or here() == Red_sun or here() == Hiadum2 or here() == Tsig or here() == Maya then global_var_random_planet = 2; end; --ледяная планета
			if here() == Barnard then global_var_random_planet = 3; end; --грибы
			if here() == Meta or here() == Eracis then global_var_random_planet = 4; end; -- пустыня
			objs():add('bolo_beacon');
		elseif global_var_event == 10 then 
			objs():add('asteroid');
		else objs():add('station');
		end;
		if global_var_reactor == 0 then walk(end3);
		elseif global_var_reactor < 3 and rnd(7) == 1 then walk(end3); return false; end;
end;
